// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from psdk_interfaces:msg/ControlMode.idl
// generated code does not contain a copyright notice

#ifndef PSDK_INTERFACES__MSG__DETAIL__CONTROL_MODE__STRUCT_H_
#define PSDK_INTERFACES__MSG__DETAIL__CONTROL_MODE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"

/// Struct defined in msg/ControlMode in the package psdk_interfaces.
typedef struct psdk_interfaces__msg__ControlMode
{
  std_msgs__msg__Header header;
  /// The modes in which the aircraft is being controlled (control loops being applied on horizontal, vertical and yaw axes of the aircraft)
  uint8_t control_mode;
  /// 0->RC  1->MSDK  4->PSDK
  uint8_t device_mode;
  /// 1->Has control authority 0->No control authority
  uint8_t control_auth;
} psdk_interfaces__msg__ControlMode;

// Struct for a sequence of psdk_interfaces__msg__ControlMode.
typedef struct psdk_interfaces__msg__ControlMode__Sequence
{
  psdk_interfaces__msg__ControlMode * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} psdk_interfaces__msg__ControlMode__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // PSDK_INTERFACES__MSG__DETAIL__CONTROL_MODE__STRUCT_H_
