// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from psdk_interfaces:msg/FlightAnomaly.idl
// generated code does not contain a copyright notice
#include "psdk_interfaces/msg/detail/flight_anomaly__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"

bool
psdk_interfaces__msg__FlightAnomaly__init(psdk_interfaces__msg__FlightAnomaly * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    psdk_interfaces__msg__FlightAnomaly__fini(msg);
    return false;
  }
  // impact_in_air
  // random_fly
  // height_ctrl_fail
  // roll_pitch_ctrl_fail
  // yaw_ctrl_fail
  // aircraft_is_falling
  // strong_wind_level1
  // strong_wind_level2
  // compass_installation_error
  // imu_installation_error
  // esc_temperature_high
  // at_least_one_esc_disconnected
  // gps_yaw_error
  // reserved
  return true;
}

void
psdk_interfaces__msg__FlightAnomaly__fini(psdk_interfaces__msg__FlightAnomaly * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // impact_in_air
  // random_fly
  // height_ctrl_fail
  // roll_pitch_ctrl_fail
  // yaw_ctrl_fail
  // aircraft_is_falling
  // strong_wind_level1
  // strong_wind_level2
  // compass_installation_error
  // imu_installation_error
  // esc_temperature_high
  // at_least_one_esc_disconnected
  // gps_yaw_error
  // reserved
}

bool
psdk_interfaces__msg__FlightAnomaly__are_equal(const psdk_interfaces__msg__FlightAnomaly * lhs, const psdk_interfaces__msg__FlightAnomaly * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // impact_in_air
  if (lhs->impact_in_air != rhs->impact_in_air) {
    return false;
  }
  // random_fly
  if (lhs->random_fly != rhs->random_fly) {
    return false;
  }
  // height_ctrl_fail
  if (lhs->height_ctrl_fail != rhs->height_ctrl_fail) {
    return false;
  }
  // roll_pitch_ctrl_fail
  if (lhs->roll_pitch_ctrl_fail != rhs->roll_pitch_ctrl_fail) {
    return false;
  }
  // yaw_ctrl_fail
  if (lhs->yaw_ctrl_fail != rhs->yaw_ctrl_fail) {
    return false;
  }
  // aircraft_is_falling
  if (lhs->aircraft_is_falling != rhs->aircraft_is_falling) {
    return false;
  }
  // strong_wind_level1
  if (lhs->strong_wind_level1 != rhs->strong_wind_level1) {
    return false;
  }
  // strong_wind_level2
  if (lhs->strong_wind_level2 != rhs->strong_wind_level2) {
    return false;
  }
  // compass_installation_error
  if (lhs->compass_installation_error != rhs->compass_installation_error) {
    return false;
  }
  // imu_installation_error
  if (lhs->imu_installation_error != rhs->imu_installation_error) {
    return false;
  }
  // esc_temperature_high
  if (lhs->esc_temperature_high != rhs->esc_temperature_high) {
    return false;
  }
  // at_least_one_esc_disconnected
  if (lhs->at_least_one_esc_disconnected != rhs->at_least_one_esc_disconnected) {
    return false;
  }
  // gps_yaw_error
  if (lhs->gps_yaw_error != rhs->gps_yaw_error) {
    return false;
  }
  // reserved
  if (lhs->reserved != rhs->reserved) {
    return false;
  }
  return true;
}

bool
psdk_interfaces__msg__FlightAnomaly__copy(
  const psdk_interfaces__msg__FlightAnomaly * input,
  psdk_interfaces__msg__FlightAnomaly * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // impact_in_air
  output->impact_in_air = input->impact_in_air;
  // random_fly
  output->random_fly = input->random_fly;
  // height_ctrl_fail
  output->height_ctrl_fail = input->height_ctrl_fail;
  // roll_pitch_ctrl_fail
  output->roll_pitch_ctrl_fail = input->roll_pitch_ctrl_fail;
  // yaw_ctrl_fail
  output->yaw_ctrl_fail = input->yaw_ctrl_fail;
  // aircraft_is_falling
  output->aircraft_is_falling = input->aircraft_is_falling;
  // strong_wind_level1
  output->strong_wind_level1 = input->strong_wind_level1;
  // strong_wind_level2
  output->strong_wind_level2 = input->strong_wind_level2;
  // compass_installation_error
  output->compass_installation_error = input->compass_installation_error;
  // imu_installation_error
  output->imu_installation_error = input->imu_installation_error;
  // esc_temperature_high
  output->esc_temperature_high = input->esc_temperature_high;
  // at_least_one_esc_disconnected
  output->at_least_one_esc_disconnected = input->at_least_one_esc_disconnected;
  // gps_yaw_error
  output->gps_yaw_error = input->gps_yaw_error;
  // reserved
  output->reserved = input->reserved;
  return true;
}

psdk_interfaces__msg__FlightAnomaly *
psdk_interfaces__msg__FlightAnomaly__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  psdk_interfaces__msg__FlightAnomaly * msg = (psdk_interfaces__msg__FlightAnomaly *)allocator.allocate(sizeof(psdk_interfaces__msg__FlightAnomaly), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(psdk_interfaces__msg__FlightAnomaly));
  bool success = psdk_interfaces__msg__FlightAnomaly__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
psdk_interfaces__msg__FlightAnomaly__destroy(psdk_interfaces__msg__FlightAnomaly * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    psdk_interfaces__msg__FlightAnomaly__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
psdk_interfaces__msg__FlightAnomaly__Sequence__init(psdk_interfaces__msg__FlightAnomaly__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  psdk_interfaces__msg__FlightAnomaly * data = NULL;

  if (size) {
    data = (psdk_interfaces__msg__FlightAnomaly *)allocator.zero_allocate(size, sizeof(psdk_interfaces__msg__FlightAnomaly), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = psdk_interfaces__msg__FlightAnomaly__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        psdk_interfaces__msg__FlightAnomaly__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
psdk_interfaces__msg__FlightAnomaly__Sequence__fini(psdk_interfaces__msg__FlightAnomaly__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      psdk_interfaces__msg__FlightAnomaly__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

psdk_interfaces__msg__FlightAnomaly__Sequence *
psdk_interfaces__msg__FlightAnomaly__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  psdk_interfaces__msg__FlightAnomaly__Sequence * array = (psdk_interfaces__msg__FlightAnomaly__Sequence *)allocator.allocate(sizeof(psdk_interfaces__msg__FlightAnomaly__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = psdk_interfaces__msg__FlightAnomaly__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
psdk_interfaces__msg__FlightAnomaly__Sequence__destroy(psdk_interfaces__msg__FlightAnomaly__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    psdk_interfaces__msg__FlightAnomaly__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
psdk_interfaces__msg__FlightAnomaly__Sequence__are_equal(const psdk_interfaces__msg__FlightAnomaly__Sequence * lhs, const psdk_interfaces__msg__FlightAnomaly__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!psdk_interfaces__msg__FlightAnomaly__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
psdk_interfaces__msg__FlightAnomaly__Sequence__copy(
  const psdk_interfaces__msg__FlightAnomaly__Sequence * input,
  psdk_interfaces__msg__FlightAnomaly__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(psdk_interfaces__msg__FlightAnomaly);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    psdk_interfaces__msg__FlightAnomaly * data =
      (psdk_interfaces__msg__FlightAnomaly *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!psdk_interfaces__msg__FlightAnomaly__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          psdk_interfaces__msg__FlightAnomaly__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!psdk_interfaces__msg__FlightAnomaly__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
