// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from psdk_interfaces:msg/FlightAnomaly.idl
// generated code does not contain a copyright notice

#ifndef PSDK_INTERFACES__MSG__DETAIL__FLIGHT_ANOMALY__STRUCT_H_
#define PSDK_INTERFACES__MSG__DETAIL__FLIGHT_ANOMALY__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"

/// Struct defined in msg/FlightAnomaly in the package psdk_interfaces.
typedef struct psdk_interfaces__msg__FlightAnomaly
{
  std_msgs__msg__Header header;
  /// 0: No impact,                      1: _impact happens in Air
  uint32_t impact_in_air;
  /// 0: Normal,                         1: Randomly fly in GPS mode without stick input
  uint32_t random_fly;
  /// 0: Height control normal,          1: Height control failed
  uint32_t height_ctrl_fail;
  /// 0: Tilt control normal,            1: Tilt control failed
  uint32_t roll_pitch_ctrl_fail;
  /// 0: Yaw control normal,             1: Yaw control failed
  uint32_t yaw_ctrl_fail;
  /// 0: Aircraft is not falling,        1: Aircraft is falling
  uint32_t aircraft_is_falling;
  /// 0: wind is under big wind level 1, 1: wind is stronger than  big wind level 1
  uint32_t strong_wind_level1;
  /// 0: wind is under big wind level 2, 1: wind is stronger than  big wind level 2
  uint32_t strong_wind_level2;
  /// 0: Compass install right,          1: Compass install error
  uint32_t compass_installation_error;
  /// 0: IMU install right,              1: IMU install error
  uint32_t imu_installation_error;
  /// 0: ESC temperature is normal,      1: ESC temperature is high
  uint32_t esc_temperature_high;
  /// 0: No ESC disconnected,            1: At least one ESC is disconnected
  uint32_t at_least_one_esc_disconnected;
  /// 0: No GPS yaw error,               1: GPS yaw error
  uint32_t gps_yaw_error;
  uint32_t reserved;
} psdk_interfaces__msg__FlightAnomaly;

// Struct for a sequence of psdk_interfaces__msg__FlightAnomaly.
typedef struct psdk_interfaces__msg__FlightAnomaly__Sequence
{
  psdk_interfaces__msg__FlightAnomaly * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} psdk_interfaces__msg__FlightAnomaly__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // PSDK_INTERFACES__MSG__DETAIL__FLIGHT_ANOMALY__STRUCT_H_
