// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from psdk_interfaces:msg/FlightStatus.idl
// generated code does not contain a copyright notice

#ifndef PSDK_INTERFACES__MSG__DETAIL__FLIGHT_STATUS__FUNCTIONS_H_
#define PSDK_INTERFACES__MSG__DETAIL__FLIGHT_STATUS__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "psdk_interfaces/msg/rosidl_generator_c__visibility_control.h"

#include "psdk_interfaces/msg/detail/flight_status__struct.h"

/// Initialize msg/FlightStatus message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * psdk_interfaces__msg__FlightStatus
 * )) before or use
 * psdk_interfaces__msg__FlightStatus__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
bool
psdk_interfaces__msg__FlightStatus__init(psdk_interfaces__msg__FlightStatus * msg);

/// Finalize msg/FlightStatus message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
void
psdk_interfaces__msg__FlightStatus__fini(psdk_interfaces__msg__FlightStatus * msg);

/// Create msg/FlightStatus message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * psdk_interfaces__msg__FlightStatus__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
psdk_interfaces__msg__FlightStatus *
psdk_interfaces__msg__FlightStatus__create();

/// Destroy msg/FlightStatus message.
/**
 * It calls
 * psdk_interfaces__msg__FlightStatus__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
void
psdk_interfaces__msg__FlightStatus__destroy(psdk_interfaces__msg__FlightStatus * msg);

/// Check for msg/FlightStatus message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
bool
psdk_interfaces__msg__FlightStatus__are_equal(const psdk_interfaces__msg__FlightStatus * lhs, const psdk_interfaces__msg__FlightStatus * rhs);

/// Copy a msg/FlightStatus message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
bool
psdk_interfaces__msg__FlightStatus__copy(
  const psdk_interfaces__msg__FlightStatus * input,
  psdk_interfaces__msg__FlightStatus * output);

/// Initialize array of msg/FlightStatus messages.
/**
 * It allocates the memory for the number of elements and calls
 * psdk_interfaces__msg__FlightStatus__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
bool
psdk_interfaces__msg__FlightStatus__Sequence__init(psdk_interfaces__msg__FlightStatus__Sequence * array, size_t size);

/// Finalize array of msg/FlightStatus messages.
/**
 * It calls
 * psdk_interfaces__msg__FlightStatus__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
void
psdk_interfaces__msg__FlightStatus__Sequence__fini(psdk_interfaces__msg__FlightStatus__Sequence * array);

/// Create array of msg/FlightStatus messages.
/**
 * It allocates the memory for the array and calls
 * psdk_interfaces__msg__FlightStatus__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
psdk_interfaces__msg__FlightStatus__Sequence *
psdk_interfaces__msg__FlightStatus__Sequence__create(size_t size);

/// Destroy array of msg/FlightStatus messages.
/**
 * It calls
 * psdk_interfaces__msg__FlightStatus__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
void
psdk_interfaces__msg__FlightStatus__Sequence__destroy(psdk_interfaces__msg__FlightStatus__Sequence * array);

/// Check for msg/FlightStatus message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
bool
psdk_interfaces__msg__FlightStatus__Sequence__are_equal(const psdk_interfaces__msg__FlightStatus__Sequence * lhs, const psdk_interfaces__msg__FlightStatus__Sequence * rhs);

/// Copy an array of msg/FlightStatus messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_psdk_interfaces
bool
psdk_interfaces__msg__FlightStatus__Sequence__copy(
  const psdk_interfaces__msg__FlightStatus__Sequence * input,
  psdk_interfaces__msg__FlightStatus__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // PSDK_INTERFACES__MSG__DETAIL__FLIGHT_STATUS__FUNCTIONS_H_
