// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from psdk_interfaces:msg/GimbalRotation.idl
// generated code does not contain a copyright notice

#ifndef PSDK_INTERFACES__MSG__DETAIL__GIMBAL_ROTATION__STRUCT_HPP_
#define PSDK_INTERFACES__MSG__DETAIL__GIMBAL_ROTATION__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__psdk_interfaces__msg__GimbalRotation __attribute__((deprecated))
#else
# define DEPRECATED__psdk_interfaces__msg__GimbalRotation __declspec(deprecated)
#endif

namespace psdk_interfaces
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct GimbalRotation_
{
  using Type = GimbalRotation_<ContainerAllocator>;

  explicit GimbalRotation_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::DEFAULTS_ONLY == _init)
    {
      this->payload_index = 1;
    } else if (rosidl_runtime_cpp::MessageInitialization::ZERO == _init) {
      this->payload_index = 0;
      this->rotation_mode = 0;
      this->pitch = 0.0f;
      this->roll = 0.0f;
      this->yaw = 0.0f;
      this->time = 0.0f;
    }
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->rotation_mode = 0;
      this->pitch = 0.0f;
      this->roll = 0.0f;
      this->yaw = 0.0f;
      this->time = 0.0f;
    }
  }

  explicit GimbalRotation_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::DEFAULTS_ONLY == _init)
    {
      this->payload_index = 1;
    } else if (rosidl_runtime_cpp::MessageInitialization::ZERO == _init) {
      this->payload_index = 0;
      this->rotation_mode = 0;
      this->pitch = 0.0f;
      this->roll = 0.0f;
      this->yaw = 0.0f;
      this->time = 0.0f;
    }
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->rotation_mode = 0;
      this->pitch = 0.0f;
      this->roll = 0.0f;
      this->yaw = 0.0f;
      this->time = 0.0f;
    }
  }

  // field types and members
  using _payload_index_type =
    uint8_t;
  _payload_index_type payload_index;
  using _rotation_mode_type =
    uint8_t;
  _rotation_mode_type rotation_mode;
  using _pitch_type =
    float;
  _pitch_type pitch;
  using _roll_type =
    float;
  _roll_type roll;
  using _yaw_type =
    float;
  _yaw_type yaw;
  using _time_type =
    float;
  _time_type time;

  // setters for named parameter idiom
  Type & set__payload_index(
    const uint8_t & _arg)
  {
    this->payload_index = _arg;
    return *this;
  }
  Type & set__rotation_mode(
    const uint8_t & _arg)
  {
    this->rotation_mode = _arg;
    return *this;
  }
  Type & set__pitch(
    const float & _arg)
  {
    this->pitch = _arg;
    return *this;
  }
  Type & set__roll(
    const float & _arg)
  {
    this->roll = _arg;
    return *this;
  }
  Type & set__yaw(
    const float & _arg)
  {
    this->yaw = _arg;
    return *this;
  }
  Type & set__time(
    const float & _arg)
  {
    this->time = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    psdk_interfaces::msg::GimbalRotation_<ContainerAllocator> *;
  using ConstRawPtr =
    const psdk_interfaces::msg::GimbalRotation_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<psdk_interfaces::msg::GimbalRotation_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<psdk_interfaces::msg::GimbalRotation_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::msg::GimbalRotation_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::msg::GimbalRotation_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::msg::GimbalRotation_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::msg::GimbalRotation_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<psdk_interfaces::msg::GimbalRotation_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<psdk_interfaces::msg::GimbalRotation_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__psdk_interfaces__msg__GimbalRotation
    std::shared_ptr<psdk_interfaces::msg::GimbalRotation_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__psdk_interfaces__msg__GimbalRotation
    std::shared_ptr<psdk_interfaces::msg::GimbalRotation_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const GimbalRotation_ & other) const
  {
    if (this->payload_index != other.payload_index) {
      return false;
    }
    if (this->rotation_mode != other.rotation_mode) {
      return false;
    }
    if (this->pitch != other.pitch) {
      return false;
    }
    if (this->roll != other.roll) {
      return false;
    }
    if (this->yaw != other.yaw) {
      return false;
    }
    if (this->time != other.time) {
      return false;
    }
    return true;
  }
  bool operator!=(const GimbalRotation_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct GimbalRotation_

// alias to use template instance with default allocator
using GimbalRotation =
  psdk_interfaces::msg::GimbalRotation_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace psdk_interfaces

#endif  // PSDK_INTERFACES__MSG__DETAIL__GIMBAL_ROTATION__STRUCT_HPP_
