// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from psdk_interfaces:msg/GimbalRotation.idl
// generated code does not contain a copyright notice

#ifndef PSDK_INTERFACES__MSG__DETAIL__GIMBAL_ROTATION__TRAITS_HPP_
#define PSDK_INTERFACES__MSG__DETAIL__GIMBAL_ROTATION__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "psdk_interfaces/msg/detail/gimbal_rotation__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace psdk_interfaces
{

namespace msg
{

inline void to_flow_style_yaml(
  const GimbalRotation & msg,
  std::ostream & out)
{
  out << "{";
  // member: payload_index
  {
    out << "payload_index: ";
    rosidl_generator_traits::value_to_yaml(msg.payload_index, out);
    out << ", ";
  }

  // member: rotation_mode
  {
    out << "rotation_mode: ";
    rosidl_generator_traits::value_to_yaml(msg.rotation_mode, out);
    out << ", ";
  }

  // member: pitch
  {
    out << "pitch: ";
    rosidl_generator_traits::value_to_yaml(msg.pitch, out);
    out << ", ";
  }

  // member: roll
  {
    out << "roll: ";
    rosidl_generator_traits::value_to_yaml(msg.roll, out);
    out << ", ";
  }

  // member: yaw
  {
    out << "yaw: ";
    rosidl_generator_traits::value_to_yaml(msg.yaw, out);
    out << ", ";
  }

  // member: time
  {
    out << "time: ";
    rosidl_generator_traits::value_to_yaml(msg.time, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const GimbalRotation & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: payload_index
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "payload_index: ";
    rosidl_generator_traits::value_to_yaml(msg.payload_index, out);
    out << "\n";
  }

  // member: rotation_mode
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "rotation_mode: ";
    rosidl_generator_traits::value_to_yaml(msg.rotation_mode, out);
    out << "\n";
  }

  // member: pitch
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "pitch: ";
    rosidl_generator_traits::value_to_yaml(msg.pitch, out);
    out << "\n";
  }

  // member: roll
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "roll: ";
    rosidl_generator_traits::value_to_yaml(msg.roll, out);
    out << "\n";
  }

  // member: yaw
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "yaw: ";
    rosidl_generator_traits::value_to_yaml(msg.yaw, out);
    out << "\n";
  }

  // member: time
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "time: ";
    rosidl_generator_traits::value_to_yaml(msg.time, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const GimbalRotation & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace psdk_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use psdk_interfaces::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const psdk_interfaces::msg::GimbalRotation & msg,
  std::ostream & out, size_t indentation = 0)
{
  psdk_interfaces::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use psdk_interfaces::msg::to_yaml() instead")]]
inline std::string to_yaml(const psdk_interfaces::msg::GimbalRotation & msg)
{
  return psdk_interfaces::msg::to_yaml(msg);
}

template<>
inline const char * data_type<psdk_interfaces::msg::GimbalRotation>()
{
  return "psdk_interfaces::msg::GimbalRotation";
}

template<>
inline const char * name<psdk_interfaces::msg::GimbalRotation>()
{
  return "psdk_interfaces/msg/GimbalRotation";
}

template<>
struct has_fixed_size<psdk_interfaces::msg::GimbalRotation>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<psdk_interfaces::msg::GimbalRotation>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<psdk_interfaces::msg::GimbalRotation>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // PSDK_INTERFACES__MSG__DETAIL__GIMBAL_ROTATION__TRAITS_HPP_
