// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from psdk_interfaces:msg/RCConnectionStatus.idl
// generated code does not contain a copyright notice

#ifndef PSDK_INTERFACES__MSG__DETAIL__RC_CONNECTION_STATUS__TRAITS_HPP_
#define PSDK_INTERFACES__MSG__DETAIL__RC_CONNECTION_STATUS__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "psdk_interfaces/msg/detail/rc_connection_status__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"

namespace psdk_interfaces
{

namespace msg
{

inline void to_flow_style_yaml(
  const RCConnectionStatus & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: air_connection
  {
    out << "air_connection: ";
    rosidl_generator_traits::value_to_yaml(msg.air_connection, out);
    out << ", ";
  }

  // member: ground_connection
  {
    out << "ground_connection: ";
    rosidl_generator_traits::value_to_yaml(msg.ground_connection, out);
    out << ", ";
  }

  // member: app_connection
  {
    out << "app_connection: ";
    rosidl_generator_traits::value_to_yaml(msg.app_connection, out);
    out << ", ";
  }

  // member: air_or_ground_disconnected
  {
    out << "air_or_ground_disconnected: ";
    rosidl_generator_traits::value_to_yaml(msg.air_or_ground_disconnected, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const RCConnectionStatus & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: air_connection
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "air_connection: ";
    rosidl_generator_traits::value_to_yaml(msg.air_connection, out);
    out << "\n";
  }

  // member: ground_connection
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "ground_connection: ";
    rosidl_generator_traits::value_to_yaml(msg.ground_connection, out);
    out << "\n";
  }

  // member: app_connection
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "app_connection: ";
    rosidl_generator_traits::value_to_yaml(msg.app_connection, out);
    out << "\n";
  }

  // member: air_or_ground_disconnected
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "air_or_ground_disconnected: ";
    rosidl_generator_traits::value_to_yaml(msg.air_or_ground_disconnected, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const RCConnectionStatus & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace psdk_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use psdk_interfaces::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const psdk_interfaces::msg::RCConnectionStatus & msg,
  std::ostream & out, size_t indentation = 0)
{
  psdk_interfaces::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use psdk_interfaces::msg::to_yaml() instead")]]
inline std::string to_yaml(const psdk_interfaces::msg::RCConnectionStatus & msg)
{
  return psdk_interfaces::msg::to_yaml(msg);
}

template<>
inline const char * data_type<psdk_interfaces::msg::RCConnectionStatus>()
{
  return "psdk_interfaces::msg::RCConnectionStatus";
}

template<>
inline const char * name<psdk_interfaces::msg::RCConnectionStatus>()
{
  return "psdk_interfaces/msg/RCConnectionStatus";
}

template<>
struct has_fixed_size<psdk_interfaces::msg::RCConnectionStatus>
  : std::integral_constant<bool, has_fixed_size<std_msgs::msg::Header>::value> {};

template<>
struct has_bounded_size<psdk_interfaces::msg::RCConnectionStatus>
  : std::integral_constant<bool, has_bounded_size<std_msgs::msg::Header>::value> {};

template<>
struct is_message<psdk_interfaces::msg::RCConnectionStatus>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // PSDK_INTERFACES__MSG__DETAIL__RC_CONNECTION_STATUS__TRAITS_HPP_
