// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from psdk_interfaces:msg/RTKYaw.idl
// generated code does not contain a copyright notice

#ifndef PSDK_INTERFACES__MSG__DETAIL__RTK_YAW__STRUCT_HPP_
#define PSDK_INTERFACES__MSG__DETAIL__RTK_YAW__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__psdk_interfaces__msg__RTKYaw __attribute__((deprecated))
#else
# define DEPRECATED__psdk_interfaces__msg__RTKYaw __declspec(deprecated)
#endif

namespace psdk_interfaces
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct RTKYaw_
{
  using Type = RTKYaw_<ContainerAllocator>;

  explicit RTKYaw_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->yaw = 0;
    }
  }

  explicit RTKYaw_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->yaw = 0;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _yaw_type =
    uint16_t;
  _yaw_type yaw;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__yaw(
    const uint16_t & _arg)
  {
    this->yaw = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    psdk_interfaces::msg::RTKYaw_<ContainerAllocator> *;
  using ConstRawPtr =
    const psdk_interfaces::msg::RTKYaw_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<psdk_interfaces::msg::RTKYaw_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<psdk_interfaces::msg::RTKYaw_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::msg::RTKYaw_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::msg::RTKYaw_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::msg::RTKYaw_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::msg::RTKYaw_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<psdk_interfaces::msg::RTKYaw_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<psdk_interfaces::msg::RTKYaw_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__psdk_interfaces__msg__RTKYaw
    std::shared_ptr<psdk_interfaces::msg::RTKYaw_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__psdk_interfaces__msg__RTKYaw
    std::shared_ptr<psdk_interfaces::msg::RTKYaw_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const RTKYaw_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->yaw != other.yaw) {
      return false;
    }
    return true;
  }
  bool operator!=(const RTKYaw_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct RTKYaw_

// alias to use template instance with default allocator
using RTKYaw =
  psdk_interfaces::msg::RTKYaw_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace psdk_interfaces

#endif  // PSDK_INTERFACES__MSG__DETAIL__RTK_YAW__STRUCT_HPP_
