// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from psdk_interfaces:msg/SDKCtrlInfo.idl
// generated code does not contain a copyright notice

#ifndef PSDK_INTERFACES__MSG__DETAIL__SDK_CTRL_INFO__STRUCT_HPP_
#define PSDK_INTERFACES__MSG__DETAIL__SDK_CTRL_INFO__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__psdk_interfaces__msg__SDKCtrlInfo __attribute__((deprecated))
#else
# define DEPRECATED__psdk_interfaces__msg__SDKCtrlInfo __declspec(deprecated)
#endif

namespace psdk_interfaces
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct SDKCtrlInfo_
{
  using Type = SDKCtrlInfo_<ContainerAllocator>;

  explicit SDKCtrlInfo_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->control_mode = 0;
      this->device_status = 0;
      this->flight_status = 0;
      this->vrc_status = 0;
      this->reserved = 0;
    }
  }

  explicit SDKCtrlInfo_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->control_mode = 0;
      this->device_status = 0;
      this->flight_status = 0;
      this->vrc_status = 0;
      this->reserved = 0;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _control_mode_type =
    uint8_t;
  _control_mode_type control_mode;
  using _device_status_type =
    uint8_t;
  _device_status_type device_status;
  using _flight_status_type =
    uint8_t;
  _flight_status_type flight_status;
  using _vrc_status_type =
    uint8_t;
  _vrc_status_type vrc_status;
  using _reserved_type =
    uint8_t;
  _reserved_type reserved;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__control_mode(
    const uint8_t & _arg)
  {
    this->control_mode = _arg;
    return *this;
  }
  Type & set__device_status(
    const uint8_t & _arg)
  {
    this->device_status = _arg;
    return *this;
  }
  Type & set__flight_status(
    const uint8_t & _arg)
  {
    this->flight_status = _arg;
    return *this;
  }
  Type & set__vrc_status(
    const uint8_t & _arg)
  {
    this->vrc_status = _arg;
    return *this;
  }
  Type & set__reserved(
    const uint8_t & _arg)
  {
    this->reserved = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    psdk_interfaces::msg::SDKCtrlInfo_<ContainerAllocator> *;
  using ConstRawPtr =
    const psdk_interfaces::msg::SDKCtrlInfo_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<psdk_interfaces::msg::SDKCtrlInfo_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<psdk_interfaces::msg::SDKCtrlInfo_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::msg::SDKCtrlInfo_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::msg::SDKCtrlInfo_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::msg::SDKCtrlInfo_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::msg::SDKCtrlInfo_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<psdk_interfaces::msg::SDKCtrlInfo_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<psdk_interfaces::msg::SDKCtrlInfo_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__psdk_interfaces__msg__SDKCtrlInfo
    std::shared_ptr<psdk_interfaces::msg::SDKCtrlInfo_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__psdk_interfaces__msg__SDKCtrlInfo
    std::shared_ptr<psdk_interfaces::msg::SDKCtrlInfo_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SDKCtrlInfo_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->control_mode != other.control_mode) {
      return false;
    }
    if (this->device_status != other.device_status) {
      return false;
    }
    if (this->flight_status != other.flight_status) {
      return false;
    }
    if (this->vrc_status != other.vrc_status) {
      return false;
    }
    if (this->reserved != other.reserved) {
      return false;
    }
    return true;
  }
  bool operator!=(const SDKCtrlInfo_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SDKCtrlInfo_

// alias to use template instance with default allocator
using SDKCtrlInfo =
  psdk_interfaces::msg::SDKCtrlInfo_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace psdk_interfaces

#endif  // PSDK_INTERFACES__MSG__DETAIL__SDK_CTRL_INFO__STRUCT_HPP_
