// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from psdk_interfaces:srv/SetObstacleAvoidance.idl
// generated code does not contain a copyright notice

#ifndef PSDK_INTERFACES__SRV__DETAIL__SET_OBSTACLE_AVOIDANCE__TRAITS_HPP_
#define PSDK_INTERFACES__SRV__DETAIL__SET_OBSTACLE_AVOIDANCE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "psdk_interfaces/srv/detail/set_obstacle_avoidance__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace psdk_interfaces
{

namespace srv
{

inline void to_flow_style_yaml(
  const SetObstacleAvoidance_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: obstacle_avoidance_on
  {
    out << "obstacle_avoidance_on: ";
    rosidl_generator_traits::value_to_yaml(msg.obstacle_avoidance_on, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SetObstacleAvoidance_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: obstacle_avoidance_on
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "obstacle_avoidance_on: ";
    rosidl_generator_traits::value_to_yaml(msg.obstacle_avoidance_on, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SetObstacleAvoidance_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace psdk_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use psdk_interfaces::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const psdk_interfaces::srv::SetObstacleAvoidance_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  psdk_interfaces::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use psdk_interfaces::srv::to_yaml() instead")]]
inline std::string to_yaml(const psdk_interfaces::srv::SetObstacleAvoidance_Request & msg)
{
  return psdk_interfaces::srv::to_yaml(msg);
}

template<>
inline const char * data_type<psdk_interfaces::srv::SetObstacleAvoidance_Request>()
{
  return "psdk_interfaces::srv::SetObstacleAvoidance_Request";
}

template<>
inline const char * name<psdk_interfaces::srv::SetObstacleAvoidance_Request>()
{
  return "psdk_interfaces/srv/SetObstacleAvoidance_Request";
}

template<>
struct has_fixed_size<psdk_interfaces::srv::SetObstacleAvoidance_Request>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<psdk_interfaces::srv::SetObstacleAvoidance_Request>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<psdk_interfaces::srv::SetObstacleAvoidance_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace psdk_interfaces
{

namespace srv
{

inline void to_flow_style_yaml(
  const SetObstacleAvoidance_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: success
  {
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SetObstacleAvoidance_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: success
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SetObstacleAvoidance_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace psdk_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use psdk_interfaces::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const psdk_interfaces::srv::SetObstacleAvoidance_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  psdk_interfaces::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use psdk_interfaces::srv::to_yaml() instead")]]
inline std::string to_yaml(const psdk_interfaces::srv::SetObstacleAvoidance_Response & msg)
{
  return psdk_interfaces::srv::to_yaml(msg);
}

template<>
inline const char * data_type<psdk_interfaces::srv::SetObstacleAvoidance_Response>()
{
  return "psdk_interfaces::srv::SetObstacleAvoidance_Response";
}

template<>
inline const char * name<psdk_interfaces::srv::SetObstacleAvoidance_Response>()
{
  return "psdk_interfaces/srv/SetObstacleAvoidance_Response";
}

template<>
struct has_fixed_size<psdk_interfaces::srv::SetObstacleAvoidance_Response>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<psdk_interfaces::srv::SetObstacleAvoidance_Response>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<psdk_interfaces::srv::SetObstacleAvoidance_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<psdk_interfaces::srv::SetObstacleAvoidance>()
{
  return "psdk_interfaces::srv::SetObstacleAvoidance";
}

template<>
inline const char * name<psdk_interfaces::srv::SetObstacleAvoidance>()
{
  return "psdk_interfaces/srv/SetObstacleAvoidance";
}

template<>
struct has_fixed_size<psdk_interfaces::srv::SetObstacleAvoidance>
  : std::integral_constant<
    bool,
    has_fixed_size<psdk_interfaces::srv::SetObstacleAvoidance_Request>::value &&
    has_fixed_size<psdk_interfaces::srv::SetObstacleAvoidance_Response>::value
  >
{
};

template<>
struct has_bounded_size<psdk_interfaces::srv::SetObstacleAvoidance>
  : std::integral_constant<
    bool,
    has_bounded_size<psdk_interfaces::srv::SetObstacleAvoidance_Request>::value &&
    has_bounded_size<psdk_interfaces::srv::SetObstacleAvoidance_Response>::value
  >
{
};

template<>
struct is_service<psdk_interfaces::srv::SetObstacleAvoidance>
  : std::true_type
{
};

template<>
struct is_service_request<psdk_interfaces::srv::SetObstacleAvoidance_Request>
  : std::true_type
{
};

template<>
struct is_service_response<psdk_interfaces::srv::SetObstacleAvoidance_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // PSDK_INTERFACES__SRV__DETAIL__SET_OBSTACLE_AVOIDANCE__TRAITS_HPP_
