// generated from rosidl_generator_cpp/resource/idl__builder.hpp.em
// with input from psdk_interfaces:msg/FlightAnomaly.idl
// generated code does not contain a copyright notice

#ifndef PSDK_INTERFACES__MSG__DETAIL__FLIGHT_ANOMALY__BUILDER_HPP_
#define PSDK_INTERFACES__MSG__DETAIL__FLIGHT_ANOMALY__BUILDER_HPP_

#include <algorithm>
#include <utility>

#include "psdk_interfaces/msg/detail/flight_anomaly__struct.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


namespace psdk_interfaces
{

namespace msg
{

namespace builder
{

class Init_FlightAnomaly_reserved
{
public:
  explicit Init_FlightAnomaly_reserved(::psdk_interfaces::msg::FlightAnomaly & msg)
  : msg_(msg)
  {}
  ::psdk_interfaces::msg::FlightAnomaly reserved(::psdk_interfaces::msg::FlightAnomaly::_reserved_type arg)
  {
    msg_.reserved = std::move(arg);
    return std::move(msg_);
  }

private:
  ::psdk_interfaces::msg::FlightAnomaly msg_;
};

class Init_FlightAnomaly_gps_yaw_error
{
public:
  explicit Init_FlightAnomaly_gps_yaw_error(::psdk_interfaces::msg::FlightAnomaly & msg)
  : msg_(msg)
  {}
  Init_FlightAnomaly_reserved gps_yaw_error(::psdk_interfaces::msg::FlightAnomaly::_gps_yaw_error_type arg)
  {
    msg_.gps_yaw_error = std::move(arg);
    return Init_FlightAnomaly_reserved(msg_);
  }

private:
  ::psdk_interfaces::msg::FlightAnomaly msg_;
};

class Init_FlightAnomaly_at_least_one_esc_disconnected
{
public:
  explicit Init_FlightAnomaly_at_least_one_esc_disconnected(::psdk_interfaces::msg::FlightAnomaly & msg)
  : msg_(msg)
  {}
  Init_FlightAnomaly_gps_yaw_error at_least_one_esc_disconnected(::psdk_interfaces::msg::FlightAnomaly::_at_least_one_esc_disconnected_type arg)
  {
    msg_.at_least_one_esc_disconnected = std::move(arg);
    return Init_FlightAnomaly_gps_yaw_error(msg_);
  }

private:
  ::psdk_interfaces::msg::FlightAnomaly msg_;
};

class Init_FlightAnomaly_esc_temperature_high
{
public:
  explicit Init_FlightAnomaly_esc_temperature_high(::psdk_interfaces::msg::FlightAnomaly & msg)
  : msg_(msg)
  {}
  Init_FlightAnomaly_at_least_one_esc_disconnected esc_temperature_high(::psdk_interfaces::msg::FlightAnomaly::_esc_temperature_high_type arg)
  {
    msg_.esc_temperature_high = std::move(arg);
    return Init_FlightAnomaly_at_least_one_esc_disconnected(msg_);
  }

private:
  ::psdk_interfaces::msg::FlightAnomaly msg_;
};

class Init_FlightAnomaly_imu_installation_error
{
public:
  explicit Init_FlightAnomaly_imu_installation_error(::psdk_interfaces::msg::FlightAnomaly & msg)
  : msg_(msg)
  {}
  Init_FlightAnomaly_esc_temperature_high imu_installation_error(::psdk_interfaces::msg::FlightAnomaly::_imu_installation_error_type arg)
  {
    msg_.imu_installation_error = std::move(arg);
    return Init_FlightAnomaly_esc_temperature_high(msg_);
  }

private:
  ::psdk_interfaces::msg::FlightAnomaly msg_;
};

class Init_FlightAnomaly_compass_installation_error
{
public:
  explicit Init_FlightAnomaly_compass_installation_error(::psdk_interfaces::msg::FlightAnomaly & msg)
  : msg_(msg)
  {}
  Init_FlightAnomaly_imu_installation_error compass_installation_error(::psdk_interfaces::msg::FlightAnomaly::_compass_installation_error_type arg)
  {
    msg_.compass_installation_error = std::move(arg);
    return Init_FlightAnomaly_imu_installation_error(msg_);
  }

private:
  ::psdk_interfaces::msg::FlightAnomaly msg_;
};

class Init_FlightAnomaly_strong_wind_level2
{
public:
  explicit Init_FlightAnomaly_strong_wind_level2(::psdk_interfaces::msg::FlightAnomaly & msg)
  : msg_(msg)
  {}
  Init_FlightAnomaly_compass_installation_error strong_wind_level2(::psdk_interfaces::msg::FlightAnomaly::_strong_wind_level2_type arg)
  {
    msg_.strong_wind_level2 = std::move(arg);
    return Init_FlightAnomaly_compass_installation_error(msg_);
  }

private:
  ::psdk_interfaces::msg::FlightAnomaly msg_;
};

class Init_FlightAnomaly_strong_wind_level1
{
public:
  explicit Init_FlightAnomaly_strong_wind_level1(::psdk_interfaces::msg::FlightAnomaly & msg)
  : msg_(msg)
  {}
  Init_FlightAnomaly_strong_wind_level2 strong_wind_level1(::psdk_interfaces::msg::FlightAnomaly::_strong_wind_level1_type arg)
  {
    msg_.strong_wind_level1 = std::move(arg);
    return Init_FlightAnomaly_strong_wind_level2(msg_);
  }

private:
  ::psdk_interfaces::msg::FlightAnomaly msg_;
};

class Init_FlightAnomaly_aircraft_is_falling
{
public:
  explicit Init_FlightAnomaly_aircraft_is_falling(::psdk_interfaces::msg::FlightAnomaly & msg)
  : msg_(msg)
  {}
  Init_FlightAnomaly_strong_wind_level1 aircraft_is_falling(::psdk_interfaces::msg::FlightAnomaly::_aircraft_is_falling_type arg)
  {
    msg_.aircraft_is_falling = std::move(arg);
    return Init_FlightAnomaly_strong_wind_level1(msg_);
  }

private:
  ::psdk_interfaces::msg::FlightAnomaly msg_;
};

class Init_FlightAnomaly_yaw_ctrl_fail
{
public:
  explicit Init_FlightAnomaly_yaw_ctrl_fail(::psdk_interfaces::msg::FlightAnomaly & msg)
  : msg_(msg)
  {}
  Init_FlightAnomaly_aircraft_is_falling yaw_ctrl_fail(::psdk_interfaces::msg::FlightAnomaly::_yaw_ctrl_fail_type arg)
  {
    msg_.yaw_ctrl_fail = std::move(arg);
    return Init_FlightAnomaly_aircraft_is_falling(msg_);
  }

private:
  ::psdk_interfaces::msg::FlightAnomaly msg_;
};

class Init_FlightAnomaly_roll_pitch_ctrl_fail
{
public:
  explicit Init_FlightAnomaly_roll_pitch_ctrl_fail(::psdk_interfaces::msg::FlightAnomaly & msg)
  : msg_(msg)
  {}
  Init_FlightAnomaly_yaw_ctrl_fail roll_pitch_ctrl_fail(::psdk_interfaces::msg::FlightAnomaly::_roll_pitch_ctrl_fail_type arg)
  {
    msg_.roll_pitch_ctrl_fail = std::move(arg);
    return Init_FlightAnomaly_yaw_ctrl_fail(msg_);
  }

private:
  ::psdk_interfaces::msg::FlightAnomaly msg_;
};

class Init_FlightAnomaly_height_ctrl_fail
{
public:
  explicit Init_FlightAnomaly_height_ctrl_fail(::psdk_interfaces::msg::FlightAnomaly & msg)
  : msg_(msg)
  {}
  Init_FlightAnomaly_roll_pitch_ctrl_fail height_ctrl_fail(::psdk_interfaces::msg::FlightAnomaly::_height_ctrl_fail_type arg)
  {
    msg_.height_ctrl_fail = std::move(arg);
    return Init_FlightAnomaly_roll_pitch_ctrl_fail(msg_);
  }

private:
  ::psdk_interfaces::msg::FlightAnomaly msg_;
};

class Init_FlightAnomaly_random_fly
{
public:
  explicit Init_FlightAnomaly_random_fly(::psdk_interfaces::msg::FlightAnomaly & msg)
  : msg_(msg)
  {}
  Init_FlightAnomaly_height_ctrl_fail random_fly(::psdk_interfaces::msg::FlightAnomaly::_random_fly_type arg)
  {
    msg_.random_fly = std::move(arg);
    return Init_FlightAnomaly_height_ctrl_fail(msg_);
  }

private:
  ::psdk_interfaces::msg::FlightAnomaly msg_;
};

class Init_FlightAnomaly_impact_in_air
{
public:
  explicit Init_FlightAnomaly_impact_in_air(::psdk_interfaces::msg::FlightAnomaly & msg)
  : msg_(msg)
  {}
  Init_FlightAnomaly_random_fly impact_in_air(::psdk_interfaces::msg::FlightAnomaly::_impact_in_air_type arg)
  {
    msg_.impact_in_air = std::move(arg);
    return Init_FlightAnomaly_random_fly(msg_);
  }

private:
  ::psdk_interfaces::msg::FlightAnomaly msg_;
};

class Init_FlightAnomaly_header
{
public:
  Init_FlightAnomaly_header()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_FlightAnomaly_impact_in_air header(::psdk_interfaces::msg::FlightAnomaly::_header_type arg)
  {
    msg_.header = std::move(arg);
    return Init_FlightAnomaly_impact_in_air(msg_);
  }

private:
  ::psdk_interfaces::msg::FlightAnomaly msg_;
};

}  // namespace builder

}  // namespace msg

template<typename MessageType>
auto build();

template<>
inline
auto build<::psdk_interfaces::msg::FlightAnomaly>()
{
  return psdk_interfaces::msg::builder::Init_FlightAnomaly_header();
}

}  // namespace psdk_interfaces

#endif  // PSDK_INTERFACES__MSG__DETAIL__FLIGHT_ANOMALY__BUILDER_HPP_
