// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from psdk_interfaces:msg/FlightAnomaly.idl
// generated code does not contain a copyright notice

#ifndef PSDK_INTERFACES__MSG__DETAIL__FLIGHT_ANOMALY__STRUCT_HPP_
#define PSDK_INTERFACES__MSG__DETAIL__FLIGHT_ANOMALY__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__psdk_interfaces__msg__FlightAnomaly __attribute__((deprecated))
#else
# define DEPRECATED__psdk_interfaces__msg__FlightAnomaly __declspec(deprecated)
#endif

namespace psdk_interfaces
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct FlightAnomaly_
{
  using Type = FlightAnomaly_<ContainerAllocator>;

  explicit FlightAnomaly_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->impact_in_air = 0ul;
      this->random_fly = 0ul;
      this->height_ctrl_fail = 0ul;
      this->roll_pitch_ctrl_fail = 0ul;
      this->yaw_ctrl_fail = 0ul;
      this->aircraft_is_falling = 0ul;
      this->strong_wind_level1 = 0ul;
      this->strong_wind_level2 = 0ul;
      this->compass_installation_error = 0ul;
      this->imu_installation_error = 0ul;
      this->esc_temperature_high = 0ul;
      this->at_least_one_esc_disconnected = 0ul;
      this->gps_yaw_error = 0ul;
      this->reserved = 0ul;
    }
  }

  explicit FlightAnomaly_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->impact_in_air = 0ul;
      this->random_fly = 0ul;
      this->height_ctrl_fail = 0ul;
      this->roll_pitch_ctrl_fail = 0ul;
      this->yaw_ctrl_fail = 0ul;
      this->aircraft_is_falling = 0ul;
      this->strong_wind_level1 = 0ul;
      this->strong_wind_level2 = 0ul;
      this->compass_installation_error = 0ul;
      this->imu_installation_error = 0ul;
      this->esc_temperature_high = 0ul;
      this->at_least_one_esc_disconnected = 0ul;
      this->gps_yaw_error = 0ul;
      this->reserved = 0ul;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _impact_in_air_type =
    uint32_t;
  _impact_in_air_type impact_in_air;
  using _random_fly_type =
    uint32_t;
  _random_fly_type random_fly;
  using _height_ctrl_fail_type =
    uint32_t;
  _height_ctrl_fail_type height_ctrl_fail;
  using _roll_pitch_ctrl_fail_type =
    uint32_t;
  _roll_pitch_ctrl_fail_type roll_pitch_ctrl_fail;
  using _yaw_ctrl_fail_type =
    uint32_t;
  _yaw_ctrl_fail_type yaw_ctrl_fail;
  using _aircraft_is_falling_type =
    uint32_t;
  _aircraft_is_falling_type aircraft_is_falling;
  using _strong_wind_level1_type =
    uint32_t;
  _strong_wind_level1_type strong_wind_level1;
  using _strong_wind_level2_type =
    uint32_t;
  _strong_wind_level2_type strong_wind_level2;
  using _compass_installation_error_type =
    uint32_t;
  _compass_installation_error_type compass_installation_error;
  using _imu_installation_error_type =
    uint32_t;
  _imu_installation_error_type imu_installation_error;
  using _esc_temperature_high_type =
    uint32_t;
  _esc_temperature_high_type esc_temperature_high;
  using _at_least_one_esc_disconnected_type =
    uint32_t;
  _at_least_one_esc_disconnected_type at_least_one_esc_disconnected;
  using _gps_yaw_error_type =
    uint32_t;
  _gps_yaw_error_type gps_yaw_error;
  using _reserved_type =
    uint32_t;
  _reserved_type reserved;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__impact_in_air(
    const uint32_t & _arg)
  {
    this->impact_in_air = _arg;
    return *this;
  }
  Type & set__random_fly(
    const uint32_t & _arg)
  {
    this->random_fly = _arg;
    return *this;
  }
  Type & set__height_ctrl_fail(
    const uint32_t & _arg)
  {
    this->height_ctrl_fail = _arg;
    return *this;
  }
  Type & set__roll_pitch_ctrl_fail(
    const uint32_t & _arg)
  {
    this->roll_pitch_ctrl_fail = _arg;
    return *this;
  }
  Type & set__yaw_ctrl_fail(
    const uint32_t & _arg)
  {
    this->yaw_ctrl_fail = _arg;
    return *this;
  }
  Type & set__aircraft_is_falling(
    const uint32_t & _arg)
  {
    this->aircraft_is_falling = _arg;
    return *this;
  }
  Type & set__strong_wind_level1(
    const uint32_t & _arg)
  {
    this->strong_wind_level1 = _arg;
    return *this;
  }
  Type & set__strong_wind_level2(
    const uint32_t & _arg)
  {
    this->strong_wind_level2 = _arg;
    return *this;
  }
  Type & set__compass_installation_error(
    const uint32_t & _arg)
  {
    this->compass_installation_error = _arg;
    return *this;
  }
  Type & set__imu_installation_error(
    const uint32_t & _arg)
  {
    this->imu_installation_error = _arg;
    return *this;
  }
  Type & set__esc_temperature_high(
    const uint32_t & _arg)
  {
    this->esc_temperature_high = _arg;
    return *this;
  }
  Type & set__at_least_one_esc_disconnected(
    const uint32_t & _arg)
  {
    this->at_least_one_esc_disconnected = _arg;
    return *this;
  }
  Type & set__gps_yaw_error(
    const uint32_t & _arg)
  {
    this->gps_yaw_error = _arg;
    return *this;
  }
  Type & set__reserved(
    const uint32_t & _arg)
  {
    this->reserved = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    psdk_interfaces::msg::FlightAnomaly_<ContainerAllocator> *;
  using ConstRawPtr =
    const psdk_interfaces::msg::FlightAnomaly_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<psdk_interfaces::msg::FlightAnomaly_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<psdk_interfaces::msg::FlightAnomaly_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::msg::FlightAnomaly_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::msg::FlightAnomaly_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::msg::FlightAnomaly_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::msg::FlightAnomaly_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<psdk_interfaces::msg::FlightAnomaly_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<psdk_interfaces::msg::FlightAnomaly_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__psdk_interfaces__msg__FlightAnomaly
    std::shared_ptr<psdk_interfaces::msg::FlightAnomaly_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__psdk_interfaces__msg__FlightAnomaly
    std::shared_ptr<psdk_interfaces::msg::FlightAnomaly_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const FlightAnomaly_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->impact_in_air != other.impact_in_air) {
      return false;
    }
    if (this->random_fly != other.random_fly) {
      return false;
    }
    if (this->height_ctrl_fail != other.height_ctrl_fail) {
      return false;
    }
    if (this->roll_pitch_ctrl_fail != other.roll_pitch_ctrl_fail) {
      return false;
    }
    if (this->yaw_ctrl_fail != other.yaw_ctrl_fail) {
      return false;
    }
    if (this->aircraft_is_falling != other.aircraft_is_falling) {
      return false;
    }
    if (this->strong_wind_level1 != other.strong_wind_level1) {
      return false;
    }
    if (this->strong_wind_level2 != other.strong_wind_level2) {
      return false;
    }
    if (this->compass_installation_error != other.compass_installation_error) {
      return false;
    }
    if (this->imu_installation_error != other.imu_installation_error) {
      return false;
    }
    if (this->esc_temperature_high != other.esc_temperature_high) {
      return false;
    }
    if (this->at_least_one_esc_disconnected != other.at_least_one_esc_disconnected) {
      return false;
    }
    if (this->gps_yaw_error != other.gps_yaw_error) {
      return false;
    }
    if (this->reserved != other.reserved) {
      return false;
    }
    return true;
  }
  bool operator!=(const FlightAnomaly_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct FlightAnomaly_

// alias to use template instance with default allocator
using FlightAnomaly =
  psdk_interfaces::msg::FlightAnomaly_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace psdk_interfaces

#endif  // PSDK_INTERFACES__MSG__DETAIL__FLIGHT_ANOMALY__STRUCT_HPP_
