// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from psdk_interfaces:msg/FlightStatus.idl
// generated code does not contain a copyright notice

#ifndef PSDK_INTERFACES__MSG__DETAIL__FLIGHT_STATUS__STRUCT_HPP_
#define PSDK_INTERFACES__MSG__DETAIL__FLIGHT_STATUS__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__psdk_interfaces__msg__FlightStatus __attribute__((deprecated))
#else
# define DEPRECATED__psdk_interfaces__msg__FlightStatus __declspec(deprecated)
#endif

namespace psdk_interfaces
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct FlightStatus_
{
  using Type = FlightStatus_<ContainerAllocator>;

  explicit FlightStatus_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->flight_status = 0;
    }
  }

  explicit FlightStatus_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->flight_status = 0;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _flight_status_type =
    uint8_t;
  _flight_status_type flight_status;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__flight_status(
    const uint8_t & _arg)
  {
    this->flight_status = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t FLIGHT_STATUS_STOPED =
    0u;
  static constexpr uint8_t FLIGHT_STATUS_ON_GROUND =
    1u;
  static constexpr uint8_t FLIGHT_STATUS_ON_AIR =
    2u;

  // pointer types
  using RawPtr =
    psdk_interfaces::msg::FlightStatus_<ContainerAllocator> *;
  using ConstRawPtr =
    const psdk_interfaces::msg::FlightStatus_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<psdk_interfaces::msg::FlightStatus_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<psdk_interfaces::msg::FlightStatus_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::msg::FlightStatus_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::msg::FlightStatus_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::msg::FlightStatus_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::msg::FlightStatus_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<psdk_interfaces::msg::FlightStatus_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<psdk_interfaces::msg::FlightStatus_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__psdk_interfaces__msg__FlightStatus
    std::shared_ptr<psdk_interfaces::msg::FlightStatus_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__psdk_interfaces__msg__FlightStatus
    std::shared_ptr<psdk_interfaces::msg::FlightStatus_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const FlightStatus_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->flight_status != other.flight_status) {
      return false;
    }
    return true;
  }
  bool operator!=(const FlightStatus_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct FlightStatus_

// alias to use template instance with default allocator
using FlightStatus =
  psdk_interfaces::msg::FlightStatus_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FlightStatus_<ContainerAllocator>::FLIGHT_STATUS_STOPED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FlightStatus_<ContainerAllocator>::FLIGHT_STATUS_ON_GROUND;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t FlightStatus_<ContainerAllocator>::FLIGHT_STATUS_ON_AIR;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace psdk_interfaces

#endif  // PSDK_INTERFACES__MSG__DETAIL__FLIGHT_STATUS__STRUCT_HPP_
