// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from psdk_interfaces:msg/GimbalRotation.idl
// generated code does not contain a copyright notice

#ifndef PSDK_INTERFACES__MSG__DETAIL__GIMBAL_ROTATION__STRUCT_H_
#define PSDK_INTERFACES__MSG__DETAIL__GIMBAL_ROTATION__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Struct defined in msg/GimbalRotation in the package psdk_interfaces.
typedef struct psdk_interfaces__msg__GimbalRotation
{
  /// see enum E_DjiMountPosition in dji_typedef.h
  uint8_t payload_index;
  /// see E_DjiGimbalRotationMode in dji_gimbal_manager.h 0 /*!< Incremental angle rotation mode, represents rotating gimbal specified angles based on current angles. */
  /// 1, /*!< Absolute angle rotation mode, represents rotating gimbal to specified angles in the ground coordinate. */
  /// 2  /*!< Speed rotation mode, specifies rotation speed of gimbal in the ground coordinate. */
  uint8_t rotation_mode;
  /// unit: radians
  float pitch;
  /// unit: radians
  float roll;
  /// unit: radians
  float yaw;
  /// /*!< Expect execution time of gimbal rotation, unit: second. */
  float time;
} psdk_interfaces__msg__GimbalRotation;

// Struct for a sequence of psdk_interfaces__msg__GimbalRotation.
typedef struct psdk_interfaces__msg__GimbalRotation__Sequence
{
  psdk_interfaces__msg__GimbalRotation * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} psdk_interfaces__msg__GimbalRotation__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // PSDK_INTERFACES__MSG__DETAIL__GIMBAL_ROTATION__STRUCT_H_
