// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from psdk_interfaces:msg/GimbalStatus.idl
// generated code does not contain a copyright notice

#ifndef PSDK_INTERFACES__MSG__DETAIL__GIMBAL_STATUS__STRUCT_H_
#define PSDK_INTERFACES__MSG__DETAIL__GIMBAL_STATUS__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"

/// Struct defined in msg/GimbalStatus in the package psdk_interfaces.
typedef struct psdk_interfaces__msg__GimbalStatus
{
  std_msgs__msg__Header header;
  /// 1 - gimbal mounted, 0 - gimbal not mounted
  uint32_t mount_status;
  uint32_t is_busy;
  /// 1 - axis reached limit, 0 - no
  uint32_t pitch_limited;
  /// 1 - axis reached limit, 0 - no
  uint32_t roll_limited;
  /// 1 - axis reached limit, 0 - no
  uint32_t yaw_limited;
  /// 1 - calibrating, 0 - no
  uint32_t calibrating;
  /// 1 - success, 0 - fail
  uint32_t prev_calibration_result;
  /// 1 - reversed for OSMO, 0 - normal
  uint32_t installed_direction;
  uint32_t disabled_mvo;
  uint32_t gear_show_unable;
  /// 1 - fault, 0 - normal
  uint32_t gyro_falut;
  /// 1 - Pitch data is normal, 0 - fault
  uint32_t esc_pitch_status;
  /// 1 - Roll data is normal, 0 - fault
  uint32_t esc_roll_status;
  /// 1 - Yaw data is normal , 0 - fault
  uint32_t esc_yaw_status;
  /// 1 - normal , 0 - at fault
  uint32_t drone_data_recv;
  /// 1 - init complete, 0 - not complete
  uint32_t init_unfinished;
  /// 1 - updating, 0 - not updating
  uint32_t fw_updating;
} psdk_interfaces__msg__GimbalStatus;

// Struct for a sequence of psdk_interfaces__msg__GimbalStatus.
typedef struct psdk_interfaces__msg__GimbalStatus__Sequence
{
  psdk_interfaces__msg__GimbalStatus * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} psdk_interfaces__msg__GimbalStatus__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // PSDK_INTERFACES__MSG__DETAIL__GIMBAL_STATUS__STRUCT_H_
