// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from psdk_interfaces:msg/GimbalStatus.idl
// generated code does not contain a copyright notice

#ifndef PSDK_INTERFACES__MSG__DETAIL__GIMBAL_STATUS__STRUCT_HPP_
#define PSDK_INTERFACES__MSG__DETAIL__GIMBAL_STATUS__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__psdk_interfaces__msg__GimbalStatus __attribute__((deprecated))
#else
# define DEPRECATED__psdk_interfaces__msg__GimbalStatus __declspec(deprecated)
#endif

namespace psdk_interfaces
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct GimbalStatus_
{
  using Type = GimbalStatus_<ContainerAllocator>;

  explicit GimbalStatus_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->mount_status = 0ul;
      this->is_busy = 0ul;
      this->pitch_limited = 0ul;
      this->roll_limited = 0ul;
      this->yaw_limited = 0ul;
      this->calibrating = 0ul;
      this->prev_calibration_result = 0ul;
      this->installed_direction = 0ul;
      this->disabled_mvo = 0ul;
      this->gear_show_unable = 0ul;
      this->gyro_falut = 0ul;
      this->esc_pitch_status = 0ul;
      this->esc_roll_status = 0ul;
      this->esc_yaw_status = 0ul;
      this->drone_data_recv = 0ul;
      this->init_unfinished = 0ul;
      this->fw_updating = 0ul;
    }
  }

  explicit GimbalStatus_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->mount_status = 0ul;
      this->is_busy = 0ul;
      this->pitch_limited = 0ul;
      this->roll_limited = 0ul;
      this->yaw_limited = 0ul;
      this->calibrating = 0ul;
      this->prev_calibration_result = 0ul;
      this->installed_direction = 0ul;
      this->disabled_mvo = 0ul;
      this->gear_show_unable = 0ul;
      this->gyro_falut = 0ul;
      this->esc_pitch_status = 0ul;
      this->esc_roll_status = 0ul;
      this->esc_yaw_status = 0ul;
      this->drone_data_recv = 0ul;
      this->init_unfinished = 0ul;
      this->fw_updating = 0ul;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _mount_status_type =
    uint32_t;
  _mount_status_type mount_status;
  using _is_busy_type =
    uint32_t;
  _is_busy_type is_busy;
  using _pitch_limited_type =
    uint32_t;
  _pitch_limited_type pitch_limited;
  using _roll_limited_type =
    uint32_t;
  _roll_limited_type roll_limited;
  using _yaw_limited_type =
    uint32_t;
  _yaw_limited_type yaw_limited;
  using _calibrating_type =
    uint32_t;
  _calibrating_type calibrating;
  using _prev_calibration_result_type =
    uint32_t;
  _prev_calibration_result_type prev_calibration_result;
  using _installed_direction_type =
    uint32_t;
  _installed_direction_type installed_direction;
  using _disabled_mvo_type =
    uint32_t;
  _disabled_mvo_type disabled_mvo;
  using _gear_show_unable_type =
    uint32_t;
  _gear_show_unable_type gear_show_unable;
  using _gyro_falut_type =
    uint32_t;
  _gyro_falut_type gyro_falut;
  using _esc_pitch_status_type =
    uint32_t;
  _esc_pitch_status_type esc_pitch_status;
  using _esc_roll_status_type =
    uint32_t;
  _esc_roll_status_type esc_roll_status;
  using _esc_yaw_status_type =
    uint32_t;
  _esc_yaw_status_type esc_yaw_status;
  using _drone_data_recv_type =
    uint32_t;
  _drone_data_recv_type drone_data_recv;
  using _init_unfinished_type =
    uint32_t;
  _init_unfinished_type init_unfinished;
  using _fw_updating_type =
    uint32_t;
  _fw_updating_type fw_updating;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__mount_status(
    const uint32_t & _arg)
  {
    this->mount_status = _arg;
    return *this;
  }
  Type & set__is_busy(
    const uint32_t & _arg)
  {
    this->is_busy = _arg;
    return *this;
  }
  Type & set__pitch_limited(
    const uint32_t & _arg)
  {
    this->pitch_limited = _arg;
    return *this;
  }
  Type & set__roll_limited(
    const uint32_t & _arg)
  {
    this->roll_limited = _arg;
    return *this;
  }
  Type & set__yaw_limited(
    const uint32_t & _arg)
  {
    this->yaw_limited = _arg;
    return *this;
  }
  Type & set__calibrating(
    const uint32_t & _arg)
  {
    this->calibrating = _arg;
    return *this;
  }
  Type & set__prev_calibration_result(
    const uint32_t & _arg)
  {
    this->prev_calibration_result = _arg;
    return *this;
  }
  Type & set__installed_direction(
    const uint32_t & _arg)
  {
    this->installed_direction = _arg;
    return *this;
  }
  Type & set__disabled_mvo(
    const uint32_t & _arg)
  {
    this->disabled_mvo = _arg;
    return *this;
  }
  Type & set__gear_show_unable(
    const uint32_t & _arg)
  {
    this->gear_show_unable = _arg;
    return *this;
  }
  Type & set__gyro_falut(
    const uint32_t & _arg)
  {
    this->gyro_falut = _arg;
    return *this;
  }
  Type & set__esc_pitch_status(
    const uint32_t & _arg)
  {
    this->esc_pitch_status = _arg;
    return *this;
  }
  Type & set__esc_roll_status(
    const uint32_t & _arg)
  {
    this->esc_roll_status = _arg;
    return *this;
  }
  Type & set__esc_yaw_status(
    const uint32_t & _arg)
  {
    this->esc_yaw_status = _arg;
    return *this;
  }
  Type & set__drone_data_recv(
    const uint32_t & _arg)
  {
    this->drone_data_recv = _arg;
    return *this;
  }
  Type & set__init_unfinished(
    const uint32_t & _arg)
  {
    this->init_unfinished = _arg;
    return *this;
  }
  Type & set__fw_updating(
    const uint32_t & _arg)
  {
    this->fw_updating = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    psdk_interfaces::msg::GimbalStatus_<ContainerAllocator> *;
  using ConstRawPtr =
    const psdk_interfaces::msg::GimbalStatus_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<psdk_interfaces::msg::GimbalStatus_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<psdk_interfaces::msg::GimbalStatus_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::msg::GimbalStatus_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::msg::GimbalStatus_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::msg::GimbalStatus_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::msg::GimbalStatus_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<psdk_interfaces::msg::GimbalStatus_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<psdk_interfaces::msg::GimbalStatus_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__psdk_interfaces__msg__GimbalStatus
    std::shared_ptr<psdk_interfaces::msg::GimbalStatus_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__psdk_interfaces__msg__GimbalStatus
    std::shared_ptr<psdk_interfaces::msg::GimbalStatus_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const GimbalStatus_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->mount_status != other.mount_status) {
      return false;
    }
    if (this->is_busy != other.is_busy) {
      return false;
    }
    if (this->pitch_limited != other.pitch_limited) {
      return false;
    }
    if (this->roll_limited != other.roll_limited) {
      return false;
    }
    if (this->yaw_limited != other.yaw_limited) {
      return false;
    }
    if (this->calibrating != other.calibrating) {
      return false;
    }
    if (this->prev_calibration_result != other.prev_calibration_result) {
      return false;
    }
    if (this->installed_direction != other.installed_direction) {
      return false;
    }
    if (this->disabled_mvo != other.disabled_mvo) {
      return false;
    }
    if (this->gear_show_unable != other.gear_show_unable) {
      return false;
    }
    if (this->gyro_falut != other.gyro_falut) {
      return false;
    }
    if (this->esc_pitch_status != other.esc_pitch_status) {
      return false;
    }
    if (this->esc_roll_status != other.esc_roll_status) {
      return false;
    }
    if (this->esc_yaw_status != other.esc_yaw_status) {
      return false;
    }
    if (this->drone_data_recv != other.drone_data_recv) {
      return false;
    }
    if (this->init_unfinished != other.init_unfinished) {
      return false;
    }
    if (this->fw_updating != other.fw_updating) {
      return false;
    }
    return true;
  }
  bool operator!=(const GimbalStatus_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct GimbalStatus_

// alias to use template instance with default allocator
using GimbalStatus =
  psdk_interfaces::msg::GimbalStatus_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace psdk_interfaces

#endif  // PSDK_INTERFACES__MSG__DETAIL__GIMBAL_STATUS__STRUCT_HPP_
