// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from psdk_interfaces:msg/PositionFused.idl
// generated code does not contain a copyright notice
#include "psdk_interfaces/msg/detail/position_fused__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `position`
#include "geometry_msgs/msg/detail/point__functions.h"

bool
psdk_interfaces__msg__PositionFused__init(psdk_interfaces__msg__PositionFused * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    psdk_interfaces__msg__PositionFused__fini(msg);
    return false;
  }
  // position
  if (!geometry_msgs__msg__Point__init(&msg->position)) {
    psdk_interfaces__msg__PositionFused__fini(msg);
    return false;
  }
  // x_health
  // y_health
  // z_health
  return true;
}

void
psdk_interfaces__msg__PositionFused__fini(psdk_interfaces__msg__PositionFused * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // position
  geometry_msgs__msg__Point__fini(&msg->position);
  // x_health
  // y_health
  // z_health
}

bool
psdk_interfaces__msg__PositionFused__are_equal(const psdk_interfaces__msg__PositionFused * lhs, const psdk_interfaces__msg__PositionFused * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // position
  if (!geometry_msgs__msg__Point__are_equal(
      &(lhs->position), &(rhs->position)))
  {
    return false;
  }
  // x_health
  if (lhs->x_health != rhs->x_health) {
    return false;
  }
  // y_health
  if (lhs->y_health != rhs->y_health) {
    return false;
  }
  // z_health
  if (lhs->z_health != rhs->z_health) {
    return false;
  }
  return true;
}

bool
psdk_interfaces__msg__PositionFused__copy(
  const psdk_interfaces__msg__PositionFused * input,
  psdk_interfaces__msg__PositionFused * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // position
  if (!geometry_msgs__msg__Point__copy(
      &(input->position), &(output->position)))
  {
    return false;
  }
  // x_health
  output->x_health = input->x_health;
  // y_health
  output->y_health = input->y_health;
  // z_health
  output->z_health = input->z_health;
  return true;
}

psdk_interfaces__msg__PositionFused *
psdk_interfaces__msg__PositionFused__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  psdk_interfaces__msg__PositionFused * msg = (psdk_interfaces__msg__PositionFused *)allocator.allocate(sizeof(psdk_interfaces__msg__PositionFused), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(psdk_interfaces__msg__PositionFused));
  bool success = psdk_interfaces__msg__PositionFused__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
psdk_interfaces__msg__PositionFused__destroy(psdk_interfaces__msg__PositionFused * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    psdk_interfaces__msg__PositionFused__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
psdk_interfaces__msg__PositionFused__Sequence__init(psdk_interfaces__msg__PositionFused__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  psdk_interfaces__msg__PositionFused * data = NULL;

  if (size) {
    data = (psdk_interfaces__msg__PositionFused *)allocator.zero_allocate(size, sizeof(psdk_interfaces__msg__PositionFused), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = psdk_interfaces__msg__PositionFused__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        psdk_interfaces__msg__PositionFused__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
psdk_interfaces__msg__PositionFused__Sequence__fini(psdk_interfaces__msg__PositionFused__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      psdk_interfaces__msg__PositionFused__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

psdk_interfaces__msg__PositionFused__Sequence *
psdk_interfaces__msg__PositionFused__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  psdk_interfaces__msg__PositionFused__Sequence * array = (psdk_interfaces__msg__PositionFused__Sequence *)allocator.allocate(sizeof(psdk_interfaces__msg__PositionFused__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = psdk_interfaces__msg__PositionFused__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
psdk_interfaces__msg__PositionFused__Sequence__destroy(psdk_interfaces__msg__PositionFused__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    psdk_interfaces__msg__PositionFused__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
psdk_interfaces__msg__PositionFused__Sequence__are_equal(const psdk_interfaces__msg__PositionFused__Sequence * lhs, const psdk_interfaces__msg__PositionFused__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!psdk_interfaces__msg__PositionFused__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
psdk_interfaces__msg__PositionFused__Sequence__copy(
  const psdk_interfaces__msg__PositionFused__Sequence * input,
  psdk_interfaces__msg__PositionFused__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(psdk_interfaces__msg__PositionFused);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    psdk_interfaces__msg__PositionFused * data =
      (psdk_interfaces__msg__PositionFused *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!psdk_interfaces__msg__PositionFused__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          psdk_interfaces__msg__PositionFused__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!psdk_interfaces__msg__PositionFused__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
