// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from psdk_interfaces:msg/RCConnectionStatus.idl
// generated code does not contain a copyright notice
#include "psdk_interfaces/msg/detail/rc_connection_status__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"

bool
psdk_interfaces__msg__RCConnectionStatus__init(psdk_interfaces__msg__RCConnectionStatus * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    psdk_interfaces__msg__RCConnectionStatus__fini(msg);
    return false;
  }
  // air_connection
  // ground_connection
  // app_connection
  // air_or_ground_disconnected
  return true;
}

void
psdk_interfaces__msg__RCConnectionStatus__fini(psdk_interfaces__msg__RCConnectionStatus * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // air_connection
  // ground_connection
  // app_connection
  // air_or_ground_disconnected
}

bool
psdk_interfaces__msg__RCConnectionStatus__are_equal(const psdk_interfaces__msg__RCConnectionStatus * lhs, const psdk_interfaces__msg__RCConnectionStatus * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // air_connection
  if (lhs->air_connection != rhs->air_connection) {
    return false;
  }
  // ground_connection
  if (lhs->ground_connection != rhs->ground_connection) {
    return false;
  }
  // app_connection
  if (lhs->app_connection != rhs->app_connection) {
    return false;
  }
  // air_or_ground_disconnected
  if (lhs->air_or_ground_disconnected != rhs->air_or_ground_disconnected) {
    return false;
  }
  return true;
}

bool
psdk_interfaces__msg__RCConnectionStatus__copy(
  const psdk_interfaces__msg__RCConnectionStatus * input,
  psdk_interfaces__msg__RCConnectionStatus * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // air_connection
  output->air_connection = input->air_connection;
  // ground_connection
  output->ground_connection = input->ground_connection;
  // app_connection
  output->app_connection = input->app_connection;
  // air_or_ground_disconnected
  output->air_or_ground_disconnected = input->air_or_ground_disconnected;
  return true;
}

psdk_interfaces__msg__RCConnectionStatus *
psdk_interfaces__msg__RCConnectionStatus__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  psdk_interfaces__msg__RCConnectionStatus * msg = (psdk_interfaces__msg__RCConnectionStatus *)allocator.allocate(sizeof(psdk_interfaces__msg__RCConnectionStatus), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(psdk_interfaces__msg__RCConnectionStatus));
  bool success = psdk_interfaces__msg__RCConnectionStatus__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
psdk_interfaces__msg__RCConnectionStatus__destroy(psdk_interfaces__msg__RCConnectionStatus * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    psdk_interfaces__msg__RCConnectionStatus__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
psdk_interfaces__msg__RCConnectionStatus__Sequence__init(psdk_interfaces__msg__RCConnectionStatus__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  psdk_interfaces__msg__RCConnectionStatus * data = NULL;

  if (size) {
    data = (psdk_interfaces__msg__RCConnectionStatus *)allocator.zero_allocate(size, sizeof(psdk_interfaces__msg__RCConnectionStatus), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = psdk_interfaces__msg__RCConnectionStatus__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        psdk_interfaces__msg__RCConnectionStatus__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
psdk_interfaces__msg__RCConnectionStatus__Sequence__fini(psdk_interfaces__msg__RCConnectionStatus__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      psdk_interfaces__msg__RCConnectionStatus__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

psdk_interfaces__msg__RCConnectionStatus__Sequence *
psdk_interfaces__msg__RCConnectionStatus__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  psdk_interfaces__msg__RCConnectionStatus__Sequence * array = (psdk_interfaces__msg__RCConnectionStatus__Sequence *)allocator.allocate(sizeof(psdk_interfaces__msg__RCConnectionStatus__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = psdk_interfaces__msg__RCConnectionStatus__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
psdk_interfaces__msg__RCConnectionStatus__Sequence__destroy(psdk_interfaces__msg__RCConnectionStatus__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    psdk_interfaces__msg__RCConnectionStatus__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
psdk_interfaces__msg__RCConnectionStatus__Sequence__are_equal(const psdk_interfaces__msg__RCConnectionStatus__Sequence * lhs, const psdk_interfaces__msg__RCConnectionStatus__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!psdk_interfaces__msg__RCConnectionStatus__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
psdk_interfaces__msg__RCConnectionStatus__Sequence__copy(
  const psdk_interfaces__msg__RCConnectionStatus__Sequence * input,
  psdk_interfaces__msg__RCConnectionStatus__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(psdk_interfaces__msg__RCConnectionStatus);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    psdk_interfaces__msg__RCConnectionStatus * data =
      (psdk_interfaces__msg__RCConnectionStatus *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!psdk_interfaces__msg__RCConnectionStatus__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          psdk_interfaces__msg__RCConnectionStatus__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!psdk_interfaces__msg__RCConnectionStatus__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
