// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from psdk_interfaces:msg/RelativeObstacleInfo.idl
// generated code does not contain a copyright notice
#include "psdk_interfaces/msg/detail/relative_obstacle_info__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"

bool
psdk_interfaces__msg__RelativeObstacleInfo__init(psdk_interfaces__msg__RelativeObstacleInfo * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    psdk_interfaces__msg__RelativeObstacleInfo__fini(msg);
    return false;
  }
  // down
  // front
  // right
  // back
  // left
  // up
  // down_health
  // front_health
  // right_health
  // back_health
  // left_health
  // up_health
  // reserved
  return true;
}

void
psdk_interfaces__msg__RelativeObstacleInfo__fini(psdk_interfaces__msg__RelativeObstacleInfo * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // down
  // front
  // right
  // back
  // left
  // up
  // down_health
  // front_health
  // right_health
  // back_health
  // left_health
  // up_health
  // reserved
}

bool
psdk_interfaces__msg__RelativeObstacleInfo__are_equal(const psdk_interfaces__msg__RelativeObstacleInfo * lhs, const psdk_interfaces__msg__RelativeObstacleInfo * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // down
  if (lhs->down != rhs->down) {
    return false;
  }
  // front
  if (lhs->front != rhs->front) {
    return false;
  }
  // right
  if (lhs->right != rhs->right) {
    return false;
  }
  // back
  if (lhs->back != rhs->back) {
    return false;
  }
  // left
  if (lhs->left != rhs->left) {
    return false;
  }
  // up
  if (lhs->up != rhs->up) {
    return false;
  }
  // down_health
  if (lhs->down_health != rhs->down_health) {
    return false;
  }
  // front_health
  if (lhs->front_health != rhs->front_health) {
    return false;
  }
  // right_health
  if (lhs->right_health != rhs->right_health) {
    return false;
  }
  // back_health
  if (lhs->back_health != rhs->back_health) {
    return false;
  }
  // left_health
  if (lhs->left_health != rhs->left_health) {
    return false;
  }
  // up_health
  if (lhs->up_health != rhs->up_health) {
    return false;
  }
  // reserved
  if (lhs->reserved != rhs->reserved) {
    return false;
  }
  return true;
}

bool
psdk_interfaces__msg__RelativeObstacleInfo__copy(
  const psdk_interfaces__msg__RelativeObstacleInfo * input,
  psdk_interfaces__msg__RelativeObstacleInfo * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // down
  output->down = input->down;
  // front
  output->front = input->front;
  // right
  output->right = input->right;
  // back
  output->back = input->back;
  // left
  output->left = input->left;
  // up
  output->up = input->up;
  // down_health
  output->down_health = input->down_health;
  // front_health
  output->front_health = input->front_health;
  // right_health
  output->right_health = input->right_health;
  // back_health
  output->back_health = input->back_health;
  // left_health
  output->left_health = input->left_health;
  // up_health
  output->up_health = input->up_health;
  // reserved
  output->reserved = input->reserved;
  return true;
}

psdk_interfaces__msg__RelativeObstacleInfo *
psdk_interfaces__msg__RelativeObstacleInfo__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  psdk_interfaces__msg__RelativeObstacleInfo * msg = (psdk_interfaces__msg__RelativeObstacleInfo *)allocator.allocate(sizeof(psdk_interfaces__msg__RelativeObstacleInfo), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(psdk_interfaces__msg__RelativeObstacleInfo));
  bool success = psdk_interfaces__msg__RelativeObstacleInfo__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
psdk_interfaces__msg__RelativeObstacleInfo__destroy(psdk_interfaces__msg__RelativeObstacleInfo * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    psdk_interfaces__msg__RelativeObstacleInfo__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
psdk_interfaces__msg__RelativeObstacleInfo__Sequence__init(psdk_interfaces__msg__RelativeObstacleInfo__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  psdk_interfaces__msg__RelativeObstacleInfo * data = NULL;

  if (size) {
    data = (psdk_interfaces__msg__RelativeObstacleInfo *)allocator.zero_allocate(size, sizeof(psdk_interfaces__msg__RelativeObstacleInfo), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = psdk_interfaces__msg__RelativeObstacleInfo__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        psdk_interfaces__msg__RelativeObstacleInfo__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
psdk_interfaces__msg__RelativeObstacleInfo__Sequence__fini(psdk_interfaces__msg__RelativeObstacleInfo__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      psdk_interfaces__msg__RelativeObstacleInfo__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

psdk_interfaces__msg__RelativeObstacleInfo__Sequence *
psdk_interfaces__msg__RelativeObstacleInfo__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  psdk_interfaces__msg__RelativeObstacleInfo__Sequence * array = (psdk_interfaces__msg__RelativeObstacleInfo__Sequence *)allocator.allocate(sizeof(psdk_interfaces__msg__RelativeObstacleInfo__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = psdk_interfaces__msg__RelativeObstacleInfo__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
psdk_interfaces__msg__RelativeObstacleInfo__Sequence__destroy(psdk_interfaces__msg__RelativeObstacleInfo__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    psdk_interfaces__msg__RelativeObstacleInfo__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
psdk_interfaces__msg__RelativeObstacleInfo__Sequence__are_equal(const psdk_interfaces__msg__RelativeObstacleInfo__Sequence * lhs, const psdk_interfaces__msg__RelativeObstacleInfo__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!psdk_interfaces__msg__RelativeObstacleInfo__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
psdk_interfaces__msg__RelativeObstacleInfo__Sequence__copy(
  const psdk_interfaces__msg__RelativeObstacleInfo__Sequence * input,
  psdk_interfaces__msg__RelativeObstacleInfo__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(psdk_interfaces__msg__RelativeObstacleInfo);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    psdk_interfaces__msg__RelativeObstacleInfo * data =
      (psdk_interfaces__msg__RelativeObstacleInfo *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!psdk_interfaces__msg__RelativeObstacleInfo__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          psdk_interfaces__msg__RelativeObstacleInfo__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!psdk_interfaces__msg__RelativeObstacleInfo__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
