// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from psdk_interfaces:msg/RelativeObstacleInfo.idl
// generated code does not contain a copyright notice

#ifndef PSDK_INTERFACES__MSG__DETAIL__RELATIVE_OBSTACLE_INFO__TRAITS_HPP_
#define PSDK_INTERFACES__MSG__DETAIL__RELATIVE_OBSTACLE_INFO__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "psdk_interfaces/msg/detail/relative_obstacle_info__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"

namespace psdk_interfaces
{

namespace msg
{

inline void to_flow_style_yaml(
  const RelativeObstacleInfo & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: down
  {
    out << "down: ";
    rosidl_generator_traits::value_to_yaml(msg.down, out);
    out << ", ";
  }

  // member: front
  {
    out << "front: ";
    rosidl_generator_traits::value_to_yaml(msg.front, out);
    out << ", ";
  }

  // member: right
  {
    out << "right: ";
    rosidl_generator_traits::value_to_yaml(msg.right, out);
    out << ", ";
  }

  // member: back
  {
    out << "back: ";
    rosidl_generator_traits::value_to_yaml(msg.back, out);
    out << ", ";
  }

  // member: left
  {
    out << "left: ";
    rosidl_generator_traits::value_to_yaml(msg.left, out);
    out << ", ";
  }

  // member: up
  {
    out << "up: ";
    rosidl_generator_traits::value_to_yaml(msg.up, out);
    out << ", ";
  }

  // member: down_health
  {
    out << "down_health: ";
    rosidl_generator_traits::value_to_yaml(msg.down_health, out);
    out << ", ";
  }

  // member: front_health
  {
    out << "front_health: ";
    rosidl_generator_traits::value_to_yaml(msg.front_health, out);
    out << ", ";
  }

  // member: right_health
  {
    out << "right_health: ";
    rosidl_generator_traits::value_to_yaml(msg.right_health, out);
    out << ", ";
  }

  // member: back_health
  {
    out << "back_health: ";
    rosidl_generator_traits::value_to_yaml(msg.back_health, out);
    out << ", ";
  }

  // member: left_health
  {
    out << "left_health: ";
    rosidl_generator_traits::value_to_yaml(msg.left_health, out);
    out << ", ";
  }

  // member: up_health
  {
    out << "up_health: ";
    rosidl_generator_traits::value_to_yaml(msg.up_health, out);
    out << ", ";
  }

  // member: reserved
  {
    out << "reserved: ";
    rosidl_generator_traits::value_to_yaml(msg.reserved, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const RelativeObstacleInfo & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: down
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "down: ";
    rosidl_generator_traits::value_to_yaml(msg.down, out);
    out << "\n";
  }

  // member: front
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "front: ";
    rosidl_generator_traits::value_to_yaml(msg.front, out);
    out << "\n";
  }

  // member: right
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "right: ";
    rosidl_generator_traits::value_to_yaml(msg.right, out);
    out << "\n";
  }

  // member: back
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "back: ";
    rosidl_generator_traits::value_to_yaml(msg.back, out);
    out << "\n";
  }

  // member: left
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "left: ";
    rosidl_generator_traits::value_to_yaml(msg.left, out);
    out << "\n";
  }

  // member: up
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "up: ";
    rosidl_generator_traits::value_to_yaml(msg.up, out);
    out << "\n";
  }

  // member: down_health
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "down_health: ";
    rosidl_generator_traits::value_to_yaml(msg.down_health, out);
    out << "\n";
  }

  // member: front_health
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "front_health: ";
    rosidl_generator_traits::value_to_yaml(msg.front_health, out);
    out << "\n";
  }

  // member: right_health
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "right_health: ";
    rosidl_generator_traits::value_to_yaml(msg.right_health, out);
    out << "\n";
  }

  // member: back_health
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "back_health: ";
    rosidl_generator_traits::value_to_yaml(msg.back_health, out);
    out << "\n";
  }

  // member: left_health
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "left_health: ";
    rosidl_generator_traits::value_to_yaml(msg.left_health, out);
    out << "\n";
  }

  // member: up_health
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "up_health: ";
    rosidl_generator_traits::value_to_yaml(msg.up_health, out);
    out << "\n";
  }

  // member: reserved
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "reserved: ";
    rosidl_generator_traits::value_to_yaml(msg.reserved, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const RelativeObstacleInfo & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace psdk_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use psdk_interfaces::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const psdk_interfaces::msg::RelativeObstacleInfo & msg,
  std::ostream & out, size_t indentation = 0)
{
  psdk_interfaces::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use psdk_interfaces::msg::to_yaml() instead")]]
inline std::string to_yaml(const psdk_interfaces::msg::RelativeObstacleInfo & msg)
{
  return psdk_interfaces::msg::to_yaml(msg);
}

template<>
inline const char * data_type<psdk_interfaces::msg::RelativeObstacleInfo>()
{
  return "psdk_interfaces::msg::RelativeObstacleInfo";
}

template<>
inline const char * name<psdk_interfaces::msg::RelativeObstacleInfo>()
{
  return "psdk_interfaces/msg/RelativeObstacleInfo";
}

template<>
struct has_fixed_size<psdk_interfaces::msg::RelativeObstacleInfo>
  : std::integral_constant<bool, has_fixed_size<std_msgs::msg::Header>::value> {};

template<>
struct has_bounded_size<psdk_interfaces::msg::RelativeObstacleInfo>
  : std::integral_constant<bool, has_bounded_size<std_msgs::msg::Header>::value> {};

template<>
struct is_message<psdk_interfaces::msg::RelativeObstacleInfo>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // PSDK_INTERFACES__MSG__DETAIL__RELATIVE_OBSTACLE_INFO__TRAITS_HPP_
