// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from psdk_interfaces:msg/SDKCtrlInfo.idl
// generated code does not contain a copyright notice
#include "psdk_interfaces/msg/detail/sdk_ctrl_info__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"

bool
psdk_interfaces__msg__SDKCtrlInfo__init(psdk_interfaces__msg__SDKCtrlInfo * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    psdk_interfaces__msg__SDKCtrlInfo__fini(msg);
    return false;
  }
  // control_mode
  // device_status
  // flight_status
  // vrc_status
  // reserved
  return true;
}

void
psdk_interfaces__msg__SDKCtrlInfo__fini(psdk_interfaces__msg__SDKCtrlInfo * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // control_mode
  // device_status
  // flight_status
  // vrc_status
  // reserved
}

bool
psdk_interfaces__msg__SDKCtrlInfo__are_equal(const psdk_interfaces__msg__SDKCtrlInfo * lhs, const psdk_interfaces__msg__SDKCtrlInfo * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // control_mode
  if (lhs->control_mode != rhs->control_mode) {
    return false;
  }
  // device_status
  if (lhs->device_status != rhs->device_status) {
    return false;
  }
  // flight_status
  if (lhs->flight_status != rhs->flight_status) {
    return false;
  }
  // vrc_status
  if (lhs->vrc_status != rhs->vrc_status) {
    return false;
  }
  // reserved
  if (lhs->reserved != rhs->reserved) {
    return false;
  }
  return true;
}

bool
psdk_interfaces__msg__SDKCtrlInfo__copy(
  const psdk_interfaces__msg__SDKCtrlInfo * input,
  psdk_interfaces__msg__SDKCtrlInfo * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // control_mode
  output->control_mode = input->control_mode;
  // device_status
  output->device_status = input->device_status;
  // flight_status
  output->flight_status = input->flight_status;
  // vrc_status
  output->vrc_status = input->vrc_status;
  // reserved
  output->reserved = input->reserved;
  return true;
}

psdk_interfaces__msg__SDKCtrlInfo *
psdk_interfaces__msg__SDKCtrlInfo__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  psdk_interfaces__msg__SDKCtrlInfo * msg = (psdk_interfaces__msg__SDKCtrlInfo *)allocator.allocate(sizeof(psdk_interfaces__msg__SDKCtrlInfo), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(psdk_interfaces__msg__SDKCtrlInfo));
  bool success = psdk_interfaces__msg__SDKCtrlInfo__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
psdk_interfaces__msg__SDKCtrlInfo__destroy(psdk_interfaces__msg__SDKCtrlInfo * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    psdk_interfaces__msg__SDKCtrlInfo__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
psdk_interfaces__msg__SDKCtrlInfo__Sequence__init(psdk_interfaces__msg__SDKCtrlInfo__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  psdk_interfaces__msg__SDKCtrlInfo * data = NULL;

  if (size) {
    data = (psdk_interfaces__msg__SDKCtrlInfo *)allocator.zero_allocate(size, sizeof(psdk_interfaces__msg__SDKCtrlInfo), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = psdk_interfaces__msg__SDKCtrlInfo__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        psdk_interfaces__msg__SDKCtrlInfo__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
psdk_interfaces__msg__SDKCtrlInfo__Sequence__fini(psdk_interfaces__msg__SDKCtrlInfo__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      psdk_interfaces__msg__SDKCtrlInfo__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

psdk_interfaces__msg__SDKCtrlInfo__Sequence *
psdk_interfaces__msg__SDKCtrlInfo__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  psdk_interfaces__msg__SDKCtrlInfo__Sequence * array = (psdk_interfaces__msg__SDKCtrlInfo__Sequence *)allocator.allocate(sizeof(psdk_interfaces__msg__SDKCtrlInfo__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = psdk_interfaces__msg__SDKCtrlInfo__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
psdk_interfaces__msg__SDKCtrlInfo__Sequence__destroy(psdk_interfaces__msg__SDKCtrlInfo__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    psdk_interfaces__msg__SDKCtrlInfo__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
psdk_interfaces__msg__SDKCtrlInfo__Sequence__are_equal(const psdk_interfaces__msg__SDKCtrlInfo__Sequence * lhs, const psdk_interfaces__msg__SDKCtrlInfo__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!psdk_interfaces__msg__SDKCtrlInfo__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
psdk_interfaces__msg__SDKCtrlInfo__Sequence__copy(
  const psdk_interfaces__msg__SDKCtrlInfo__Sequence * input,
  psdk_interfaces__msg__SDKCtrlInfo__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(psdk_interfaces__msg__SDKCtrlInfo);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    psdk_interfaces__msg__SDKCtrlInfo * data =
      (psdk_interfaces__msg__SDKCtrlInfo *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!psdk_interfaces__msg__SDKCtrlInfo__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          psdk_interfaces__msg__SDKCtrlInfo__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!psdk_interfaces__msg__SDKCtrlInfo__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
