// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from psdk_interfaces:srv/CameraSetupStreaming.idl
// generated code does not contain a copyright notice

#ifndef PSDK_INTERFACES__SRV__DETAIL__CAMERA_SETUP_STREAMING__STRUCT_H_
#define PSDK_INTERFACES__SRV__DETAIL__CAMERA_SETUP_STREAMING__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Struct defined in srv/CameraSetupStreaming in the package psdk_interfaces.
typedef struct psdk_interfaces__srv__CameraSetupStreaming_Request
{
  /// please refer to enum E_DjiLiveViewCameraPosition in dji_liveview.h
  uint8_t payload_index;
  /// please refer to enum E_DjiLiveViewCameraSource in dji_liveview.h
  uint8_t camera_source;
  /// 0 for stop and 1 for start
  bool start_stop;
  /// 0 for encoded output and 1 for decoded output
  bool decoded_output;
} psdk_interfaces__srv__CameraSetupStreaming_Request;

// Struct for a sequence of psdk_interfaces__srv__CameraSetupStreaming_Request.
typedef struct psdk_interfaces__srv__CameraSetupStreaming_Request__Sequence
{
  psdk_interfaces__srv__CameraSetupStreaming_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} psdk_interfaces__srv__CameraSetupStreaming_Request__Sequence;


// Constants defined in the message

/// Struct defined in srv/CameraSetupStreaming in the package psdk_interfaces.
typedef struct psdk_interfaces__srv__CameraSetupStreaming_Response
{
  bool success;
} psdk_interfaces__srv__CameraSetupStreaming_Response;

// Struct for a sequence of psdk_interfaces__srv__CameraSetupStreaming_Response.
typedef struct psdk_interfaces__srv__CameraSetupStreaming_Response__Sequence
{
  psdk_interfaces__srv__CameraSetupStreaming_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} psdk_interfaces__srv__CameraSetupStreaming_Response__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // PSDK_INTERFACES__SRV__DETAIL__CAMERA_SETUP_STREAMING__STRUCT_H_
