// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from psdk_interfaces:srv/CameraSetupStreaming.idl
// generated code does not contain a copyright notice

#ifndef PSDK_INTERFACES__SRV__DETAIL__CAMERA_SETUP_STREAMING__STRUCT_HPP_
#define PSDK_INTERFACES__SRV__DETAIL__CAMERA_SETUP_STREAMING__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__psdk_interfaces__srv__CameraSetupStreaming_Request __attribute__((deprecated))
#else
# define DEPRECATED__psdk_interfaces__srv__CameraSetupStreaming_Request __declspec(deprecated)
#endif

namespace psdk_interfaces
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct CameraSetupStreaming_Request_
{
  using Type = CameraSetupStreaming_Request_<ContainerAllocator>;

  explicit CameraSetupStreaming_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::DEFAULTS_ONLY == _init)
    {
      this->payload_index = 1;
      this->camera_source = 0;
      this->decoded_output = true;
    } else if (rosidl_runtime_cpp::MessageInitialization::ZERO == _init) {
      this->payload_index = 0;
      this->camera_source = 0;
      this->start_stop = false;
      this->decoded_output = false;
    }
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->start_stop = false;
    }
  }

  explicit CameraSetupStreaming_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::DEFAULTS_ONLY == _init)
    {
      this->payload_index = 1;
      this->camera_source = 0;
      this->decoded_output = true;
    } else if (rosidl_runtime_cpp::MessageInitialization::ZERO == _init) {
      this->payload_index = 0;
      this->camera_source = 0;
      this->start_stop = false;
      this->decoded_output = false;
    }
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->start_stop = false;
    }
  }

  // field types and members
  using _payload_index_type =
    uint8_t;
  _payload_index_type payload_index;
  using _camera_source_type =
    uint8_t;
  _camera_source_type camera_source;
  using _start_stop_type =
    bool;
  _start_stop_type start_stop;
  using _decoded_output_type =
    bool;
  _decoded_output_type decoded_output;

  // setters for named parameter idiom
  Type & set__payload_index(
    const uint8_t & _arg)
  {
    this->payload_index = _arg;
    return *this;
  }
  Type & set__camera_source(
    const uint8_t & _arg)
  {
    this->camera_source = _arg;
    return *this;
  }
  Type & set__start_stop(
    const bool & _arg)
  {
    this->start_stop = _arg;
    return *this;
  }
  Type & set__decoded_output(
    const bool & _arg)
  {
    this->decoded_output = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    psdk_interfaces::srv::CameraSetupStreaming_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const psdk_interfaces::srv::CameraSetupStreaming_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<psdk_interfaces::srv::CameraSetupStreaming_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<psdk_interfaces::srv::CameraSetupStreaming_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::srv::CameraSetupStreaming_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::srv::CameraSetupStreaming_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::srv::CameraSetupStreaming_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::srv::CameraSetupStreaming_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<psdk_interfaces::srv::CameraSetupStreaming_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<psdk_interfaces::srv::CameraSetupStreaming_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__psdk_interfaces__srv__CameraSetupStreaming_Request
    std::shared_ptr<psdk_interfaces::srv::CameraSetupStreaming_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__psdk_interfaces__srv__CameraSetupStreaming_Request
    std::shared_ptr<psdk_interfaces::srv::CameraSetupStreaming_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const CameraSetupStreaming_Request_ & other) const
  {
    if (this->payload_index != other.payload_index) {
      return false;
    }
    if (this->camera_source != other.camera_source) {
      return false;
    }
    if (this->start_stop != other.start_stop) {
      return false;
    }
    if (this->decoded_output != other.decoded_output) {
      return false;
    }
    return true;
  }
  bool operator!=(const CameraSetupStreaming_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct CameraSetupStreaming_Request_

// alias to use template instance with default allocator
using CameraSetupStreaming_Request =
  psdk_interfaces::srv::CameraSetupStreaming_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace psdk_interfaces


#ifndef _WIN32
# define DEPRECATED__psdk_interfaces__srv__CameraSetupStreaming_Response __attribute__((deprecated))
#else
# define DEPRECATED__psdk_interfaces__srv__CameraSetupStreaming_Response __declspec(deprecated)
#endif

namespace psdk_interfaces
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct CameraSetupStreaming_Response_
{
  using Type = CameraSetupStreaming_Response_<ContainerAllocator>;

  explicit CameraSetupStreaming_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
    }
  }

  explicit CameraSetupStreaming_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
    }
  }

  // field types and members
  using _success_type =
    bool;
  _success_type success;

  // setters for named parameter idiom
  Type & set__success(
    const bool & _arg)
  {
    this->success = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    psdk_interfaces::srv::CameraSetupStreaming_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const psdk_interfaces::srv::CameraSetupStreaming_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<psdk_interfaces::srv::CameraSetupStreaming_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<psdk_interfaces::srv::CameraSetupStreaming_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::srv::CameraSetupStreaming_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::srv::CameraSetupStreaming_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::srv::CameraSetupStreaming_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::srv::CameraSetupStreaming_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<psdk_interfaces::srv::CameraSetupStreaming_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<psdk_interfaces::srv::CameraSetupStreaming_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__psdk_interfaces__srv__CameraSetupStreaming_Response
    std::shared_ptr<psdk_interfaces::srv::CameraSetupStreaming_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__psdk_interfaces__srv__CameraSetupStreaming_Response
    std::shared_ptr<psdk_interfaces::srv::CameraSetupStreaming_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const CameraSetupStreaming_Response_ & other) const
  {
    if (this->success != other.success) {
      return false;
    }
    return true;
  }
  bool operator!=(const CameraSetupStreaming_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct CameraSetupStreaming_Response_

// alias to use template instance with default allocator
using CameraSetupStreaming_Response =
  psdk_interfaces::srv::CameraSetupStreaming_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace psdk_interfaces

namespace psdk_interfaces
{

namespace srv
{

struct CameraSetupStreaming
{
  using Request = psdk_interfaces::srv::CameraSetupStreaming_Request;
  using Response = psdk_interfaces::srv::CameraSetupStreaming_Response;
};

}  // namespace srv

}  // namespace psdk_interfaces

#endif  // PSDK_INTERFACES__SRV__DETAIL__CAMERA_SETUP_STREAMING__STRUCT_HPP_
