// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from psdk_interfaces:srv/SetObstacleAvoidance.idl
// generated code does not contain a copyright notice

#ifndef PSDK_INTERFACES__SRV__DETAIL__SET_OBSTACLE_AVOIDANCE__STRUCT_HPP_
#define PSDK_INTERFACES__SRV__DETAIL__SET_OBSTACLE_AVOIDANCE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__psdk_interfaces__srv__SetObstacleAvoidance_Request __attribute__((deprecated))
#else
# define DEPRECATED__psdk_interfaces__srv__SetObstacleAvoidance_Request __declspec(deprecated)
#endif

namespace psdk_interfaces
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct SetObstacleAvoidance_Request_
{
  using Type = SetObstacleAvoidance_Request_<ContainerAllocator>;

  explicit SetObstacleAvoidance_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->obstacle_avoidance_on = false;
    }
  }

  explicit SetObstacleAvoidance_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->obstacle_avoidance_on = false;
    }
  }

  // field types and members
  using _obstacle_avoidance_on_type =
    bool;
  _obstacle_avoidance_on_type obstacle_avoidance_on;

  // setters for named parameter idiom
  Type & set__obstacle_avoidance_on(
    const bool & _arg)
  {
    this->obstacle_avoidance_on = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    psdk_interfaces::srv::SetObstacleAvoidance_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const psdk_interfaces::srv::SetObstacleAvoidance_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<psdk_interfaces::srv::SetObstacleAvoidance_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<psdk_interfaces::srv::SetObstacleAvoidance_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::srv::SetObstacleAvoidance_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::srv::SetObstacleAvoidance_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::srv::SetObstacleAvoidance_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::srv::SetObstacleAvoidance_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<psdk_interfaces::srv::SetObstacleAvoidance_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<psdk_interfaces::srv::SetObstacleAvoidance_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__psdk_interfaces__srv__SetObstacleAvoidance_Request
    std::shared_ptr<psdk_interfaces::srv::SetObstacleAvoidance_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__psdk_interfaces__srv__SetObstacleAvoidance_Request
    std::shared_ptr<psdk_interfaces::srv::SetObstacleAvoidance_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SetObstacleAvoidance_Request_ & other) const
  {
    if (this->obstacle_avoidance_on != other.obstacle_avoidance_on) {
      return false;
    }
    return true;
  }
  bool operator!=(const SetObstacleAvoidance_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SetObstacleAvoidance_Request_

// alias to use template instance with default allocator
using SetObstacleAvoidance_Request =
  psdk_interfaces::srv::SetObstacleAvoidance_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace psdk_interfaces


#ifndef _WIN32
# define DEPRECATED__psdk_interfaces__srv__SetObstacleAvoidance_Response __attribute__((deprecated))
#else
# define DEPRECATED__psdk_interfaces__srv__SetObstacleAvoidance_Response __declspec(deprecated)
#endif

namespace psdk_interfaces
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct SetObstacleAvoidance_Response_
{
  using Type = SetObstacleAvoidance_Response_<ContainerAllocator>;

  explicit SetObstacleAvoidance_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
    }
  }

  explicit SetObstacleAvoidance_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
    }
  }

  // field types and members
  using _success_type =
    bool;
  _success_type success;

  // setters for named parameter idiom
  Type & set__success(
    const bool & _arg)
  {
    this->success = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    psdk_interfaces::srv::SetObstacleAvoidance_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const psdk_interfaces::srv::SetObstacleAvoidance_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<psdk_interfaces::srv::SetObstacleAvoidance_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<psdk_interfaces::srv::SetObstacleAvoidance_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::srv::SetObstacleAvoidance_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::srv::SetObstacleAvoidance_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      psdk_interfaces::srv::SetObstacleAvoidance_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<psdk_interfaces::srv::SetObstacleAvoidance_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<psdk_interfaces::srv::SetObstacleAvoidance_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<psdk_interfaces::srv::SetObstacleAvoidance_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__psdk_interfaces__srv__SetObstacleAvoidance_Response
    std::shared_ptr<psdk_interfaces::srv::SetObstacleAvoidance_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__psdk_interfaces__srv__SetObstacleAvoidance_Response
    std::shared_ptr<psdk_interfaces::srv::SetObstacleAvoidance_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SetObstacleAvoidance_Response_ & other) const
  {
    if (this->success != other.success) {
      return false;
    }
    return true;
  }
  bool operator!=(const SetObstacleAvoidance_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SetObstacleAvoidance_Response_

// alias to use template instance with default allocator
using SetObstacleAvoidance_Response =
  psdk_interfaces::srv::SetObstacleAvoidance_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace psdk_interfaces

namespace psdk_interfaces
{

namespace srv
{

struct SetObstacleAvoidance
{
  using Request = psdk_interfaces::srv::SetObstacleAvoidance_Request;
  using Response = psdk_interfaces::srv::SetObstacleAvoidance_Response;
};

}  // namespace srv

}  // namespace psdk_interfaces

#endif  // PSDK_INTERFACES__SRV__DETAIL__SET_OBSTACLE_AVOIDANCE__STRUCT_HPP_
